<?php
include 'crypto.php';
include 'sqlconn.php';

$OTP_WAIT_TIME = 119000;

$ERROR_NO_ACCOUNT_FOUND = 104;
$ERROR_AUTH_FAILED = 103;
$ERROR_ALREADY_EXISTS = 107;

$GET_INFO_REQUEST = 1;
$UPDATE_INFO_REQUEST = 2;
$UPLOAD_PP_REQUEST = 3;
$UPLOAD_PP_URL_REQUEST = 4;
$PASSWORD_CHANGE_REQUEST = 5;
$OTP_REQUEST = 6;
$OTP_VALIDITY_AVAILABLE = 111;
$OTP_CANNOT_SENT = 112;
$ACCOUNT_EXISTING_REQUEST = 7;


$requestType = $_POST['request'] ?? $_GET['request'] ?? 0;

// if($requestType != 0){

    if($requestType == $GET_INFO_REQUEST){
        $inputContents = file_get_contents("php://input");
        
        if(isset($inputContents)){
            $jsonObject = json_decode($inputContents, true);
            $uuid = $jsonObject['uuid'];
            $password = $jsonObject['password'];
            
            echoInfoData($uuid, $password);
        }else{
            die("Invalid sign in request");
        }
    }else if($requestType == $UPDATE_INFO_REQUEST){
        updateInfo();
      
    }else if($requestType == $UPLOAD_PP_REQUEST){
        // $target_dir = "files/";
        
        $targetDirectory = "../media/avatars/";
        
        // Print or log the contents of $_FILES
        // print_r($_FILES);
        
        if(isset($_FILES["file"])) {
            $fileDataStr = explode("|", urldecode(basename($_FILES["file"]["name"])));
            
            $fileName = $fileDataStr[0];
            $uuid = $fileDataStr[1];
            
            $target_file = $targetDirectory . $fileName;
        
            if (move_uploaded_file($_FILES["file"]["tmp_name"], $target_file)) {
                
                $conn = createSqlConnection();
                $updateData = $conn->prepare("UPDATE USERS SET pp_name = ? WHERE uuid = ?");
                
                $updateData->bind_param("ss", $fileName, $uuid);
            
                $result = $updateData->execute();
                
                if($result && $conn->affected_rows > 0){
                    echo "success";
                }else{
                    echo "failed_data";
                }
            } else {
                echo "failed";
            }
        } else {
            echo "failed2";
        }
    }else if($requestType == $UPLOAD_PP_URL_REQUEST){
        $uuid = $_POST['uuid'];
        if($uuid === null){
            die("Invalid user");
            return;
        }
        
        $conn = createSqlConnection();
        $updateData = $conn->prepare("UPDATE USERS SET pp_url = ? WHERE uuid = ?");
        
        $updateData->bind_param("ss", $_POST['pp_url'], $uuid);
    
        $result = $updateData->execute();
        
        if($result && $conn->affected_rows > 0){
            echo  json_encode(['success' => true, 'response' => 'Profile photo url uploaded']);
        }else{
            echo  json_encode(['success' => false, 'response' => 'Failed to upload profile photo url']);
        }
    }else if($requestType == $PASSWORD_CHANGE_REQUEST){
        $uuid = $_POST['uuid'];
        $oldPass = $_POST['password'];
        $newPass = $_POST['new_password'];
        
        if($uuid === null){
            die("InvalidUser");
            return;
        }
        
        $conn = createSqlConnection();
        
        if(!verifyAuth($conn, $uuid, $oldPass)){
            echo json_encode(['success' => false, 'errcode' => 0x050, 'response' => "Authentication failed"]);
            return;
        }
    
        $updateData = $conn->prepare("UPDATE USERS SET enc_password = ? WHERE uuid = ?");
    
        $updateData->bind_param("ss", encryptValue($newPass, $newPass), $uuid);
    
        $result = $updateData->execute();
        if ($result && $conn->affected_rows > 0) {
            echo json_encode(['success' => true, 'response' => 'Password changed successfully']);
        } else {
            echo json_encode(['success' => false, 'errcode' => 0x00, 'response' => $conn->error]);
        }
    }else if($requestType == $OTP_REQUEST){
        $deviceId = $_POST['device_id'];
        $phone = $_POST['userPhone'];
        
        if($deviceId === null || $phone === null){
            echo json_encode(['success' => false, 'errcode' => 0x00, 'response'=> "Invalid user request"]);
            return;
        }
        
        $conn = createSqlConnection();
        
        $query = "SELECT * FROM OTP WHERE phone = '$phone'";
        $result = $conn->query($query);
        $newRequester = $result->num_rows == 0;
        
        $characters = '123456789';
        $otp = '';
        for ($i = 0; $i < 4; $i++) {
            $otp .= $characters[random_int(0, strlen($characters) - 1)];
        }
        
        $timestamp = round(microtime(true) * 1000);

        if($newRequester){
            $insertData = $conn->prepare("INSERT INTO OTP (device_id, phone, valid_otp, last_received, total_received) VALUES (?, ?, ?, ?, 1)");
     
            $insertData->bind_param("ssii", $deviceId, $phone, $otp, $timestamp);
            $result = $insertData->execute();
            
            $otpData = ['wait_millis' => 119000];
            echo json_encode(['success' => true, 'response' => $otpData]);
        }else{
            $oldData = [];
            while($row = $result->fetch_assoc()) {
                $oldData = $row;
            }
            
            $timeGone = $timestamp - $oldData['last_received'];
            
            if($timeGone > $OTP_WAIT_TIME){
                $insertData = $conn->prepare("UPDATE OTP SET valid_otp = ?, last_received = ?, total_received = total_received + 1 WHERE phone = ?");
         
                $insertData->bind_param("iis", $otp, $timestamp, $phone);
                $result = $insertData->execute();
                
                $otpData = ['wait_millis' => 119000];
                echo json_encode(['success' => true, 'response' => $otpData]);
            }else{
                $otpData = ['wait_millis' => ($OTP_WAIT_TIME - $timeGone)];
                echo json_encode(['success' => false, 'errcode' => $OTP_VALIDITY_AVAILABLE, 'response' => $otpData]);
            }
        }
    }else if($requestType == $ACCOUNT_EXISTING_REQUEST){
        $conn = createSqlConnection();
        
        $phone = $_GET['userPhone'];
        
        if($phone === null){
            echo json_encode(['success'=>false, 'errcode'=>0x00, 'response'=>"Invalid request"]);
            return;
        }
        
        if(isAccountExists($conn, $phone)){
            echo json_encode(['success' => false, 'errcode' => $ERROR_ALREADY_EXISTS, 'response' => "Already account created with phone '$phone'"]);
            
        }else{
            echo json_encode(['success' => true, 'response' => 'Account can create with this information']);
        }
    }
// }else{
//     echo json_encode(['success' => false, 'errcode' => 0x00, 'response' => 'Invlid request']);
// }


function echoInfoData($uuid, $pass){
    if($pass === null || $user === null){
        die("Failed: Invalid request");
    }
    
    $query = "SELECT * FROM $tableName WHERE uuid = '$uuid'";
    $result = $conn->query($query);
    $userFound = $result->num_rows > 0;

    if($userFound){
        $data = [];
        while ($row = $result->fetch_assoc()) {
            $data = $row;
        }
        
        $hashedPassword = hash('sha256', $pass);
        if($hashedPassword === $data['password']){
            echo json_encode(['success' => true, 'response' => json_encode($data)]);
        }else{
            echo json_encode(['success' => false, 'errcode' => $GLOBALS['ERROR_AUTH_FAILED'], 'response' => "Authentication failed"]);
        }
    }else{
        echo json_encode(['success' => false, 'errcode' => $GLOBALS['ERROR_NO_ACCOUNT_FOUND'], 'response' => "User not found"]);
    }
}


function updateInfo(){
    
    $conn = createSqlConnection();
    
    $uuid = $_POST['uuid'];
    $password = $_POST['password'];
    $fullName = $_POST['full_name'];
    $village = $_POST['village'];
    $upazila = $_POST['upazila'];
    $union = $_POST['union'];
    $gender = $_POST['gender'];
    $bloodGroup = $_POST['blood_group'];
    $district = $_POST['district'];
    $dobMillis = $_POST['dob_millis'];
    $email = $_POST['email'];
    
    if(!verifyAuth($conn, $uuid, $password)){
        return;
    }
    
    
    $insertData = $conn->prepare("UPDATE USERS SET full_name = ?, email = ?, gender = ?, blood_group = ?, district = ?, upazila = ?, `union` = ?, village = ?, dob_millis = ? WHERE uuid = ?");
    $insertData->bind_param("ssiiiiisis", $fullName, $email, $gender, $bloodGroup, $district, $upazila, $union, $village, $dobMillis, $uuid);

    $result = $insertData->execute();
    if ($result && $conn->affected_rows > 0) {
        echo json_encode(['success' => true, 'response' => 'Data updated successfully']);
    } else {
        echo json_encode(['success' => false, 'message' => $conn->error, 'errcode' => 0x02]);
    }
}

function verifyAuth($conn, $uuid, $pass){
    if($pass == null || $uuid == null){
        echo json_encode(['success' => false, 'errcode' => 0x01, 'response' => "Invalid auth request"]);
        return false;
    }
    
    $query = "SELECT * FROM USERS WHERE uuid = '$uuid'";
    $result = $conn->query($query);
    $userFound = $result->num_rows > 0;

    if($userFound){
        $data = [];
        while ($row = $result->fetch_assoc()) {
            $data = $row;
        }
        
        $hashedPassword = hash('sha256', $pass);
        if($hashedPassword === $data['password']){
            // echo json_encode(['success' => true, 'response' => json_encode($data)]);
            return true;
        }else{
            echo json_encode(['success' => false, 'errcode' => $GLOBALS['ERROR_AUTH_FAILED'], 'response' => "Authentication failed ".$pass]);
            return false;
        }
    }else {
        echo json_encode(['success' => false, 'errcode' => $GLOBALS['ERROR_AUTH_FAILED'], 'response' => "No account found"]);
            return false;
    }
}

function isAccountExists($conn, $phone){
    $select_query = "SELECT * FROM USERS WHERE phone = '$phone'";
    $result = $conn->query($select_query);
    return $result->num_rows > 0;
}


?>