<?php 

include 'crypto.php';
include 'sqlconn.php';

$ERROR_NO_ACCOUNT_FOUND = 104;
$ERROR_AUTH_FAILED = 103;

$ERROR_BANNED = 108;
$ERROR_OTP_MISMATCH = 113;

$ACCOUNT_CREATE_REQUEST = 8;
$request = $_POST['request'] ?? 0;

if($request == 17){
    $phone = $_POST['emailOrPhone'];
    $password = $_POST['password'];
    authUser($phone, $password, true);
}else if($request == $ACCOUNT_CREATE_REQUEST){
    $phone = $_POST['userPhone'];
    $fullName = $_POST['fullName'];
    $password = $_POST['password'];
    $otp = $_POST['otp'];
    
    registerAccount($fullName, $phone, $password, $otp);
}else if($request == 18){
    $uuid = $_POST['uuid'];
    $deviceId = $_POST['device_id'];
    
    $conn = createSqlConnection();
    $conn->query("UPDATE DEVICES SET logged_in = 0 WHERE user = '$uuid' AND device_id = '$deviceId'");
    echo json_encode(['success'=> $conn->affected_rows > 0]);
}
else{
    die("Invalid authentication request");
}

function registerAccount($name, $phone, $pass, $otp){
    if($name === null || $phone === null || $pass === null || $otp === null){
        die("Failed: Invalid sign up data");
    }
    
    $conn = createSqlConnection();
    $conn->set_charset("utf8");
    
    if(!isValidOTP($conn, $phone, $otp)){
        echo json_encode(['success' => false, 'errcode'=>$GLOBALS['ERROR_OTP_MISMATCH'], 'response'=>"Invalid OTP Code"]);
        return;
    }
    if(isAccountExists($conn, $phone)){
        echo json_encode(['success' => false, 'errcode' => $GLOBALS['ERROR_ALREADY_EXISTS'], 'response' => "Account already exists"]);
        return;
    }
    
    $timestamp = round(microtime(true) * 1000);

    $insertData = $conn->prepare("INSERT INTO USERS (full_name, phone, password, joined_millis) VALUES (?, ?, ?, ?)");
    
    $hashedPass = hash('sha256', $pass);
    $insertData->bind_param("sssi", $name, $phone, $hashedPass, $timestamp);

    $result = $insertData->execute();

    if ($result) {
        
        $inserted_id = $conn->insert_id;
        
        $select_query = "SELECT * FROM USERS WHERE row_id = $inserted_id";
        $result = $conn->query($select_query);
        
        $dataAdded = $result->num_rows > 0;
        
        if($dataAdded){
            echo json_encode(['success' => true, 'response' => 'Signed up successfully']);
        }else{
            echo json_encode(['success' => false, 'errcode' => 0x00, 'response' => "Info not added to database"]);
        }
    } else {
        echo json_encode(['success' => false, 'message' => $conn->error]);
    }
}


function isAccountExists($conn, $phone){
    $select_query = "SELECT * FROM USERS WHERE phone = '$phone'";
    $result = $conn->query($select_query);
    return $result->num_rows > 0;
}

function isValidOTP($conn, $phone, $otp){
    $select_query = "SELECT * FROM OTP WHERE phone = '$phone'";
    $result = $conn->query($select_query);
    
    if($result->num_rows>0){
        $data = [];
        while ($row = $result->fetch_assoc()) {
            $data = $row;
        }
        
        if($otp == $data['valid_otp']){
            return true;
        }else return false;
    }else false;
}



// echo filesize("php://input");
// echo json_decode(file_get_contents("php://input"), true)['k1'];

function authUser($emailOrPhone, $pass, $new = false){
    if($emailOrPhone === null || $pass === null){
        die("Failed: Invalid sign in data");
    }
    
    $tableName = "USERS";
    
    $conn = createSqlConnection();
    
    $query = "SELECT * FROM $tableName WHERE phone = '$emailOrPhone'";
    $result = $conn->query($query);
    $userFound = $result->num_rows > 0;
    
    if($userFound === false){
        $queryByUser = "SELECT * FROM $tableName WHERE email = '$emailOrPhone'";

        $result = $conn->query($queryByUser);
        $userFound = $result->num_rows > 0;
    }

    if($userFound){
        
        $data = $result->fetch_assoc();
        
        $hashedPassword = hash('sha256', $pass);
        if($hashedPassword === $data['password']){
            echo json_encode(['success' => true, 'response' => json_encode($data)]);
            updateDeviceData($conn, $data['uuid']);
        }else{
            echo json_encode(['success' => false, 'errcode' => $GLOBALS['ERROR_AUTH_FAILED'], 'response' => "Authentication failed"]);
        }
        
        
    }else{
        echo json_encode(['success' => false, 'errcode' => $GLOBALS['ERROR_NO_ACCOUNT_FOUND'], 'response' => "User not found"]);
    }
}

function updateDeviceData($conn, $user){
    $brand = $_POST['phone_brand'];
    $model = $_POST['phone_model'];
    $deviceId = $_POST['device_id'];
    
    $time = microtime(true);
    $dataBind = null;
    if($conn->query("SELECT row_id FROM DEVICES WHERE user = '$user' AND device_id = '$deviceId'")->num_rows > 0){
        $dataBind = $conn->prepare("UPDATE DEVICES SET brand = ?, model = ?, update_time = ?, logged_in = 1 WHERE device_id = ? AND user = ?");
        $dataBind->bind_param('ssiss', $brand, $model, $time, $deviceId, $user);
        
    }else{
        $dataBind = $conn->prepare("INSERT INTO DEVICES (user, brand, model, device_id, join_time, update_time) VALUES(?, ?, ?, ?, ?, ?)");
        $dataBind->bind_param('ssssii', $user, $brand, $model, $deviceId, $time, $time);
    }
    
    $dataBind->execute();
}





?>