<?php
$salt = openssl_random_pseudo_bytes(16); // Generate a random salt

// Derive a key using PBKDF2
function deriveKey($password, $salt) {
    return hash_pbkdf2('sha256', $password, $salt, 10000, 32, true);
}

// Encrypt function using derived key
function encryptValue($plaintext, $password) {
    $salt = openssl_random_pseudo_bytes(16); // Generate random salt for each encryption
    $key = deriveKey($password, $salt);
    $iv = openssl_random_pseudo_bytes(openssl_cipher_iv_length('aes-256-cbc'));
    $encrypted = openssl_encrypt($plaintext, 'aes-256-cbc', $key, 0, $iv);
    // Return encrypted data, IV, and salt as a single base64-encoded string
    return base64_encode($encrypted . '::' . base64_encode($iv) . '::' . base64_encode($salt));
}

// Decrypt function using derived key
function decryptValue($encrypted, $password) {
    list($encrypted_data, $iv, $salt) = explode('::', base64_decode($encrypted), 3);
    $key = deriveKey($password, base64_decode($salt));
    return openssl_decrypt($encrypted_data, 'aes-256-cbc', $key, 0, base64_decode($iv));
}


?>
