<?php

include("sqlconn.php");

$REQUEST_UPDATE_CLICKS = 9;
$REQUEST_GET_SERVICE = 10;
$REQUEST_ADD_SERVICE = 11;
$REQUEST_UPDATE_SERVICE = 16;
$REUQEST_UPDATE_SERVICE = 16;
$REQUEST_GET_SERVICE_LIST = 12;
$REQUEST_GET_ADDABLE_SERVICE_LIST = 13;
$REQUEST_GET_EDIT_SERVICE = 14;
$REQUEST_GET_SERVICE_DETAILS = 15;

$SERVICE_TYPE_BLOOD_DONOR = 104;
$SERVICE_TYPE_TUITION = 106;
$SERVICE_TYPE_AMBULANCE = 105;
$SERVICE_TYPE_FIRE = 107;
$SERVICE_TYPE_POLICE = 109;
$SERVICE_TYPE_MECHANICS = 112;
$SERVICE_TYPE_BUY_SELL = 123;
$SERVICE_TYPE_HOSPITAL = 100;
$SERVICE_TYPE_EDU_INST = 102; //EDUCATION INSTITUTES
$SERVICE_TYPE_DOCTOR = 101;

$ERROR_NO_DATA_FOUND = 114;
$ERROR_TYPE_DATA_ADD = 221;

$requestType = $_GET['request'] ?? 0;
if($requestType != 0){

    if($requestType == $REQUEST_GET_SERVICE_LIST){
        $data = json_decode(file_get_contents("php://input"), true);
        $localeCode = $data['locale'];
        getServiceList($localeCode, $data['version_code']);
    }else if($requestType == $REQUEST_GET_ADDABLE_SERVICE_LIST){
        $data = json_decode(file_get_contents("php://input"), true);
        $localeCode = $data['locale'];
        getAddableServiceList($localeCode, $data['version_code']);
        
    }else if($requestType == $REQUEST_GET_SERVICE){
        $data = json_decode(file_get_contents("php://input"), true);
        $serviceType = $data['service_type'];
        $basicsOnly = $data['basics_only'] ?? false;
        $uuid = $data['uuid'] ?? null;
        
        if($serviceType == $SERVICE_TYPE_BLOOD_DONOR){
            getBloodDonorList();
        }else if($serviceType == $SERVICE_TYPE_TUITION){
            getTuitionData();
        }else if($serviceType == $SERVICE_TYPE_AMBULANCE){
            getAmbulanceData($basicsOnly, $uuid);
        }else if($serviceType == $SERVICE_TYPE_FIRE){
            getFireData();
        }else if($serviceType == $SERVICE_TYPE_POLICE){
            getPoliceData();
        }else if($serviceType == $SERVICE_TYPE_EDU_INST){
            getEduData($data['sub_category'] ?? 0, $basicsOnly, $uuid);
        }else if($serviceType == $SERVICE_TYPE_HOSPITAL){
            getHospital($data['sub_category'] ?? 0, $basicsOnly, $uuid);
        }else if($serviceType == $SERVICE_TYPE_MECHANICS){
            getMechanics($basicsOnly, $uuid, $data['sub_category'] ?? 0);
        }else if($serviceType == $SERVICE_TYPE_BUY_SELL){
            getProducts($data['sub_category'] ?? 0, $basicsOnly, $uuid);
        }else if($serviceType == $SERVICE_TYPE_DOCTOR){
            getDoctors($data['sub_category'] ?? 0, $basicsOnly, $uuid);
        }else{
            noDataFound();
        }
    }else if($requestType == $REQUEST_GET_EDIT_SERVICE){
        $data = json_decode(file_get_contents("php://input"), true);
        $serviceType = $data['service_type'];
        $uuid = $data['uuid'];
        $rowId = $data['row_id'];

        if($serviceType == $SERVICE_TYPE_TUITION){
            getTuitionForEdit($uuid);
        }else if($serviceType == $SERVICE_TYPE_AMBULANCE){
            getAmbulanceEditData($uuid, $rowId);
        }else if($serviceType == $SERVICE_TYPE_MECHANICS){
            getMechanicsForEdit(true, $uuid);
        }else if($serviceType == $SERVICE_TYPE_EDU_INST){
            getEduForEdit($serviceType, $rowId);
        }else if($serviceType == $SERVICE_TYPE_BLOOD_DONOR){
            getBloodDonorForEdit($uuid);
        }else if($serviceType == $SERVICE_TYPE_HOSPITAL){
            getHospitalForEdit($rowId, $uuid);
        }else if($serviceType == $SERVICE_TYPE_DOCTOR){
            getDoctorForEdit($rowId, $uuid);
        }else if($serviceType == $SERVICE_TYPE_BUY_SELL){
            getProductForEdit($rowId, $uuid);
        }else{
            noDataFound();
        }
    }else if($requestType == $REQUEST_GET_SERVICE_DETAILS){
        $data = json_decode(file_get_contents("php://input"), true);
        $serviceType = $data['service_type'];
        $rowId = $data['row_id'];
        
        $isEducation = $serviceType == $SERVICE_TYPE_EDU_INST;
        
        if($isEducation){
            getEduDetails($serviceType, $rowId);
        }else if($serviceType == $SERVICE_TYPE_BUY_SELL){
            getProductDetails($rowId);
        }else if($serviceType == $SERVICE_TYPE_HOSPITAL){
            getHealthInstDetails($rowId);
        }else if($serviceType == $SERVICE_TYPE_DOCTOR){
            getDoctorDetails($rowId);
        }
        
    }
}

function noDataFound(){
    echo json_encode(['success' => false, 'errcode' => $GLOBALS['ERROR_NO_DATA_FOUND'], 'response' => "No data found"]);
}
function getServiceList($localeCode, $appVersion){
    $conn = createSqlConnection();
    
    $query = "SELECT * FROM SERVICES ORDER BY sn";
    $result = $conn->query($query);
    $dataFound = $result->num_rows > 0;

    if($dataFound){
        $data = null;
        while ($row = $result->fetch_assoc()) {
            $requiredVersion = $row['required_version'];
            if($requiredVersion <= $appVersion && $row['enabled'] == true){
                $name = $localeCode === "en" ? $row['en_name'] : $row['name'];
                
                $data[] = ['name' => $name, 'service' => $row['service'], 'category' => $row['category'], 'icon_url' => $row['icon']];
            }
        }
        
        echo json_encode(['success' => true, 'response' => $data]);
    }
}

function getAddableServiceList($localeCode, $appVersion){
    $conn = createSqlConnection();
    
    $query = "SELECT * FROM SERVICES ORDER BY sn";
    $result = $conn->query($query);
    $dataFound = $result->num_rows > 0;

    if($dataFound){
        $data = null;
        $resultData = null;
        while ($row = $result->fetch_assoc()) {
            $requiredVersion = $row['required_version'];
            if($requiredVersion <= $appVersion && $row['has_access'] == true){
                $name = $localeCode === "en" ? $row['en_name'] : $row['name'];
                
                $data[] = ['name' => $name, 'service' => $row['service'], 'category' => $row['category'], 'icon_url' => $row['icon'], 'enabled' => $row['enabled']];
            }
        }
        
        echo json_encode(['success' => true, 'response' => $data]);
    }
}


function getBloodDonorList(){
    $conn = createSqlConnection();
    
    $query = "SELECT bd.row_id as id, bd.last_donate, bd.clicks, bd.total_donate as donate_count,
              u.full_name as name, u.blood_group, u.village, u.district, u.upazila,
              u.`union`, u.pp_name as avatar_url FROM BLOOD_DONORS bd JOIN USERS u 
              ON bd.user = u.uuid WHERE bd.enabled = 1";
              
    $result = $conn->query($query);
    $dataFound = $result->num_rows > 0;

    if($dataFound){
        $data = null;
        $resultData = null;
        while ($row = $result->fetch_assoc()) {
            // $data[] = $row;
            // $name = $row['full_name'];
            // $group = $row['blood_group'];
            // $address = $row['village'];
            // $avatar = $row['pp_name'];
            // $row_id = $row['row_id'];
            // $last_donate = $row['last_donate'];
            // $totalDonate = $row['total_donate'];
            // $available = true;
            
            $resultData[] = $row;
        }
        echo json_encode(['success' => true, 'response' => json_encode($resultData)]);
    }else{
        noDataFound();
    }
}


function getBloodDonorForEdit($user){
    $conn = createSqlConnection();
    
    $query = "SELECT row_id, last_donate, enabled FROM BLOOD_DONORS WHERE user = '$user'";
              
    $result = $conn->query($query);
    $dataFound = $result->num_rows > 0;

    if($dataFound){
        $row = $result->fetch_assoc();
        $row['enabled'] = $row['enabled'] == 1;
        echo json_encode(['success' => true, 'response' => json_encode($row)]);
    }else{
        noDataFound();
    }
}


function getTuitionData(){
    $conn = createSqlConnection();
    
    $query = "SELECT tp.*,
          USERS.full_name, USERS.village, USERS.pp_name, 
          USERS.gender, USERS.phone
          FROM TUITION_POSTS tp 
          JOIN USERS ON tp.user = USERS.uuid 
          WHERE tp.visibility = 1 AND tp.enabled = 1";

    $result = $conn->query($query);
    $dataFound = $result->num_rows > 0;

    if($dataFound){
        $data = null;
        $resultData = null;
        while ($row = $result->fetch_assoc()) {
            $name = $row['full_name'];
            $address = $row['village'];
            $avatar = $row['pp_name'];
            $gender = $row['gender'];
            $phone = $row['phone'];
            $education = $row['education_data'];
            $type = $row['type'];
            $clicks = $row['clicks'];
            $rowId = $row['row_id'];
            
            
            $resultData[] = ['row_id' => $rowId, 'name' => $name, 'gender' => $gender, 'address' => $address, 'avatar' => $avatar, 'avatar_url' => $avatar, 'education' => $education, 'phone' => $phone, 'clicks' => $clicks];
        }
        echo json_encode(['success' => true, 'response' => json_encode($resultData)]);
    }else{
        noDataFound();
    }
}


function getTuitionForEdit($user){
    
    $conn = createSqlConnection();
    
    $query = "SELECT * FROM TUITION_POSTS WHERE user = '$user'";

    $result = $conn->query($query);
    $dataFound = $result->num_rows > 0;

    if($dataFound){
        $row = $result->fetch_assoc();
        
        $row['enabled'] = $row['enabled'] == 1;
        echo json_encode(['success' => true, 'response' => json_encode($row)]);
    }else{
        noDataFound();
    }
}


function getAmbulanceData($basicOnly, $user){
    
    $conn = createSqlConnection();
    
    //For public
    $query = "SELECT * FROM AMBULANCE WHERE visibility = 1";
    if($basicOnly){
        //For editor
        $query = "SELECT * FROM AMBULANCE WHERE user = '$user'";
    }
    
    $result = $conn->query($query);
    $dataFound = $result->num_rows > 0;

    if($dataFound){
        $resultData = null;
        while ($row = $result->fetch_assoc()) {
            
            if($basicOnly){
                $resultData[] = ['row_id' => $row['row_id'], 'title' => $row['title'], 'subtitle' => $row['proprietor'], 'status' => $row['visibility'], 'image' => "https://cdn.minidevbd.com/m/p/icons/ambulance-128.png"];
                continue;
            }
            
            $rowId = $row['row_id'];
            $title = $row['title'];
            $proprietor = $row['proprietor'];
            
            $districtId = $row['district'];
            $upazilaId = $row['upazila'];
            $unionId = $row['union'];
            $road = $row['location_name'];
            
            $phone = $row['phone'];
            $clicks = $row['clicks'];
            $coveredArea = $row['service_area'];
            
            $resultData[] = ['row_id' => $rowId, 'title' => $title, 'area' => $coveredArea, 'road' => $road, 'district_id' => $districtId, 'upazila_id' => $upazilaId, 'union_id' => $unionId, 'proprietor' => $proprietor, 'phone' => $phone, 'clicks' => $clicks];
        
        }
        
        echo json_encode(['success' => true, 'response' => json_encode($resultData)]);
    }else{
        noDataFound();
    }
}


function getMechanics($basicOnly, $user, $subCategory){
    
    $conn = createSqlConnection();
    
    //For public
    $query = "SELECT mec.*, USERS.full_name,
             USERS.district, USERS.upazila, USERS.`union`,
             USERS.village, USERS.phone, USERS.pp_name
             FROM MECHANICS mec JOIN USERS ON mec.user = USERS.uuid 
             WHERE mec.visibility = 1 AND mec.category = $subCategory AND mec.enabled = 1";
    if($basicOnly){
        //For editor
        $query = "SELECT * FROM MECHANICS WHERE user = '$user'";
    }
    
    $result = $conn->query($query);
    $dataFound = $result->num_rows > 0;

    if($dataFound){
        $resultData = null;
        $data = null;
        
        while ($row = $result->fetch_assoc()) {
            // if($basicOnly){
            //     $resultData[] = ['row_id' => $row['row_id'], 'title' => $row['title'], 'subtitle' => $row['proprietor'], 'status' => $row['visibility'], 'image' => "https://cdn.minidevbd.com/m/p/icons/ambulance-128.png"];
            //     continue;
            // }
            
            if($row['source'] == 1){
                $resultData[] = ['row_id' => $row['row_id'], 'name' => $row['name'], 'phone' => $row['phone'], 'road' => $row['location_name'], "image" => $row['image_name'], 'district_id' => $row['district_id'], 'upazila_id' => $row['upazila_id'], 'union_id' => $row['union_id'], 'experience' => $row['experience'], 'clicks' => $row['clicks']];
            }else{
                // $data[] = $row;
                
                $ppUrl = $row['pp_name'] == "" ? $row['image_name'] : "https://muthomymensingh.minidevbd.com/media/avatars/" . $row['pp_name'];
                
                $resultData[] = ['row_id' => $row['row_id'], 'name' => $row['full_name'], 'experience' => $row['experience'], 'road' => $row['village'], 'district_id' => $row['district'], 'upazila_id' => $row['upazila'], 'union_id' => $row['union'], 'phone' => $row['phone'], 'image' => $ppUrl, 'clicks' => $row['clicks']];
            }
        }
        
        echo json_encode(['success' => true, 'response' => json_encode($resultData)]);
    }else{
        noDataFound();
    }
}

function getMechanicsForEdit($isNarrow, $user){
    
    $conn = createSqlConnection();
    
    $query = "SELECT * FROM MECHANICS WHERE user = '$user'";
    
    $result = $conn->query($query);
    $dataFound = $result->num_rows > 0;

    if($dataFound){
        $resultData = null;
        $data = null;
        
        $row = $result->fetch_assoc();
        
        if($isNarrow){
            $resultData = ['category' => $row['category'], 
                           'addt_phone' => $row['phone'] ?? '', 
                           'experience' => $row['experience'], 
                           'enabled' => $row['enabled'] == 1,
                           'row_id' => $row['row_id']
                           ];
        }
        
        echo json_encode(['success' => true, 'response' => json_encode($resultData)]);
    }else{
        noDataFound();
    }
}

function getProducts($subCategory, $basicOnly, $user){
    
    $conn = createSqlConnection();
    $tableName = "PRODUCTS";
    
    //For public
    $query = "SELECT row_id, title, phone, district_id, upazila_id, 
                union_id, price, images, clicks FROM $tableName 
                WHERE visibility = 1 AND category = $subCategory";
                
    if($basicOnly){
        $query = "SELECT row_id, title, category, images FROM $tableName WHERE user = '$user'";
    }
    
    $result = $conn->query($query);
    $dataFound = $result->num_rows > 0;

    if($dataFound){
        $resultData = null;
        $data = null;
        
        while ($row = $result->fetch_assoc()) {
            $resultData[] = $row;
        }
        
        echo json_encode(['success' => true, 'response' => json_encode($resultData)]);
    }else{
        noDataFound();
    }
}

function getProductDetails($rowId){
    
    $conn = createSqlConnection();
    $tableName = "PRODUCTS";
    
    //For public
    $query = "SELECT $tableName.*, USERS.full_name FROM $tableName JOIN USERS ON $tableName.user = USERS.uuid WHERE $tableName.row_id = $rowId";
    
    $result = $conn->query($query);
    $dataFound = $result->num_rows > 0;

    if($dataFound){
        $resultData = null;
        $data = null;
        
        $row = $result->fetch_assoc();
        
        $brand = $row['brand'] == null ? "N/A" : $row['brand'];
        
        $resultData = ['desc' => $row['description'], 'condition' => $row['product_condition'], 
                        'phone' => $row['phone'], 'district_id' => $row['district_id'], 
                        'upazila_id' => $row['upazila_id'], 'union_id' => $row['union_id'], 
                        'road' => $row['location_name'], 'price_fixed' => $row['price_fixed'] == 1, 
                        'brand' => $brand, 'seller' => $row['full_name'], 'post_at' => $row['post_time'], 
                        'update_at' => $row['update_time'], 'has_wa' => $row['phone_has_wa'] == 1];
         
        updateViewCount($GLOBALS['SERVICE_TYPE_BUY_SELL'], $rowId, false);
        echo json_encode(['success' => true, 'response' => json_encode($resultData)]);
        
    }else{
        noDataFound();
    }
}

function getProductForEdit($rowId, $uuid){
    
    $conn = createSqlConnection();
    $tableName = "PRODUCTS";
    
    //For public
    $query = "SELECT * FROM $tableName WHERE row_id = $rowId AND user = '$uuid'";
    
    $result = $conn->query($query);
    $dataFound = $result->num_rows > 0;

    if($dataFound){
        
        $row = $result->fetch_assoc();
        
        echo json_encode(['success' => true, 'response' => json_encode($row)]);
        
    }else{
        noDataFound();
    }
}


function getEduData($category, $basicOnly, $user){
    
    $conn = createSqlConnection();

    $query = "SELECT * FROM EDU_INSTITUTES WHERE category = $category";
    if($basicOnly){
        $query = "SELECT row_id, name, principal_name as principal, 
                 official, email, website, student_total as students, 
                 phone, established_year as year, logo, location_name as road, 
                 district_id, upazila_id, union_id, category
                 FROM EDU_INSTITUTES WHERE user = '$user'";
    }
    
    $result = $conn->query($query);
    $dataFound = $result->num_rows > 0;

    if($dataFound){
        $resultData = null;
        while ($row = $result->fetch_assoc()) {
            
            if($basicOnly){
                $resultData[] = $row;//['row_id' => $row['row_id'], 'name' => $row['name'], 'subtitle' => $row['proprietor'], 'status' => $row['visibility'], 'image' => "https://cdn.minidevbd.com/m/p/icons/ambulance-128.png"];
                continue;
            }
            
            $rowId = $row['row_id'];
            $title = $row['name'];

            $districtId = $row['district_id'];
            $upazilaId = $row['upazila_id'];
            $unionId = $row['union_id'];
            $road = $row['location_name'];
            
            $estYear = $row['established_year'];
            $image_name = $row['logo'] == null ? "" : $row['logo'];
            
            $clicks = $row['clicks'];

            $resultData[] = ['row_id' => $rowId, 'name' => $title, 'loc' => $road, 'district_id' => $districtId, 'upazila_id' => $upazilaId, 'union_id' => $unionId, 'image_name' => $image_name, 'clicks' => $clicks, 'est' => $estYear];
        
        }
        
        echo json_encode(['success' => true, 'response' => json_encode($resultData)]);
    }else{
        noDataFound();
    }
}


function getEduForEdit($type, $rowId){
    
    $conn = createSqlConnection();

    $query = "SELECT district_id as district, upazila_id as upazila, 
            union_id `union`, name, principal_name as principal, 
            official, phone, website, email, student_total as students,
            category, established_year as est_year, logo, location_name, 
            eiin FROM EDU_INSTITUTES WHERE row_id = $rowId";
    
    $result = $conn->query($query);
    $dataFound = $result->num_rows > 0;

    if($dataFound){
        $resultData = null;
        $row = $result->fetch_assoc();
        
        echo json_encode(['success' => true, 'response' => json_encode($row)]);
    }else{
        noDataFound();
    }
}

function getHospital($category, $basicOnly, $user){
    
    $conn = createSqlConnection();

    $tableName = "HOSPITALS";
    $forAttach = $_GET['for_attach'] ?? '0';
    
    $query = "SELECT * FROM $tableName WHERE visibility = 1 AND category = $category";
    if($basicOnly){
        $query = "SELECT name, row_id, location_name as location, logo, category FROM $tableName WHERE user = '$user'";
    }else if($forAttach == '1'){
        $query = "SELECT * FROM $tableName WHERE visibility = 1 AND category != 4";
    }
    
    $result = $conn->query($query);
    $dataFound = $result->num_rows > 0;

    if($dataFound){
        $resultData = null;
        while ($row = $result->fetch_assoc()) {
            
            if($basicOnly){
                $resultData[] = $row;
                continue;
            }
            
            $rowId = $row['row_id'];
            $title = $row['name'];

            $districtId = $row['district_id'];
            $upazilaId = $row['upazila_id'];
            $unionId = $row['union_id'];
            $road = $row['location_name'];
            $estYear = $row['est_year'];
            $image_name = $row['logo'] == null ? "" : $row['logo'];
            
            $clicks = $row['clicks'];

            $resultData[] = ['row_id' => $rowId, 'name' => $title, 'loc' => $road, 'district_id' => $districtId, 'upazila_id' => $upazilaId, 'union_id' => $unionId, 'logo' => $image_name, 'clicks' => $clicks, 'est' => $estYear, 'category' => $row['category']];
        
        }
        
        echo json_encode(['success' => true, 'response' => json_encode($resultData)]);
    }else{
        noDataFound();
    }
}


function getHealthInstDetails($rowId){
    
    $conn = createSqlConnection();
    $tableName = "HOSPITALS";
    
    //For public
    $query = "SELECT * FROM $tableName WHERE row_id = $rowId";
    
    $result = $conn->query($query);
    $dataFound = $result->num_rows > 0;

    if($dataFound){
        $resultData = null;
        $data = null;
        
        $row = $result->fetch_assoc();
        
        updateViewCount($GLOBALS['SERVICE_TYPE_HOSPITAL'], $rowId, false);
        echo json_encode(['success' => true, 'response' => json_encode($row)]);
        
    }else{
        noDataFound();
    }
}

function getHospitalForEdit($rowId, $user){
    
    $conn = createSqlConnection();

    $tableName = "HOSPITALS";
    
    $query = "SELECT name, room_count as rooms, sit_count as sits, est_year, 
                location_name as location, phone, category, district_id as district, 
                upazila_id as upazila, union_id as `union`, official, phone, website, 
                email, timing, about, logo FROM $tableName WHERE row_id = $rowId AND user = '$user'";

    $result = $conn->query($query);
    $dataFound = $result->num_rows > 0;

    if($dataFound){
        $resultData = null;
        $row = $result->fetch_assoc();

        echo json_encode(['success' => true, 'response' => json_encode($row)]);
    }else{
        noDataFound();
    }
}

function getEduDetails($type, $rowId){
    
    $conn = createSqlConnection();

    
    $query = "SELECT * FROM EDU_INSTITUTES WHERE row_id = $rowId";
  
    $result = $conn->query($query);
    $dataFound = $result->num_rows > 0;

    if($dataFound){
        $row = $result->fetch_assoc();

        $phone = $row['phone'];
        $official = $row['official'];
        $principal = $row['principal_name'];
        $website = $row['website'];
        $email = $row['email'];
        $studentCount = $row['student_total'];
        
        $resultData = ['phone' => $phone, 'official' => $official, 'principal' => $principal, 'website' => $website, 'email' => $email, 'students' => $studentCount];
        
        echo json_encode(['success' => true, 'response' => json_encode($resultData)]);
        updateViewCount($type, $rowId, false);
        
    }else{
        echo json_encode(['success' => false, 'errcode' => $GLOBALS['ERROR_NO_DATA_FOUND'], 'response' => "No data found in this service"]);
    }
}

function getDoctors($category, $basicOnly, $user){
    
    $conn = createSqlConnection();

    $query = "SELECT * FROM DOCTORS WHERE visibility = 1 AND category = $category";
    if($basicOnly){
        $query = "SELECT name, row_id, qualifications, image_name, category FROM DOCTORS WHERE user = '$user'";
    }
    
    $result = $conn->query($query);
    $dataFound = $result->num_rows > 0;

    if($dataFound){
        $resultData = null;
        while ($row = $result->fetch_assoc()) {
            
            $resultData[] = $row;
            
        }
        
        echo json_encode(['success' => true, 'response' => json_encode($resultData)]);
    }else{
        noDataFound();
    }
}

function getDoctorDetails($rowId){
    
    $conn = createSqlConnection();
    
    $query = "SELECT * FROM DOCTORS WHERE row_id = $rowId";
    
    $result = $conn->query($query);
    $dataFound = $result->num_rows > 0;

    if($dataFound){
        $row = $result->fetch_assoc();
        $row['chambers'] = getDoctorChambers($conn, $row['row_id']);
        
        updateViewCount($GLOBALS['SERVICE_TYPE_DOCTOR'], $rowId, false);

        echo json_encode(['success' => true, 'response' => json_encode($row)]);
    }else{
        noDataFound();
    }
}

function getDoctorForEdit($rowId, $user){
    
    $conn = createSqlConnection();
    
    $tableName = "DOCTORS";
    
    $query = "SELECT name, qualifications, description, category, road as location, phone, email,
                district_id, upazila_id, union_id, with_personal, image_name as image, 
                experience_year as exp_year
                FROM $tableName WHERE row_id = $rowId AND user = '$user'";

    $result = $conn->query($query);
    $dataFound = $result->num_rows > 0;

    if($dataFound){
        $resultData = null;
        $row = $result->fetch_assoc();
        $row['chambers'] = getDoctorChambers($conn, $rowId /*As doctor id*/);

        echo json_encode(['success' => true, 'response' => json_encode($row)]);
    }else{
        noDataFound();
    }
}


function getDoctorChambers($conn, $doctorId){
    $result = [];
    
    $queryResult = $conn->query("SELECT H.name as hospital_name, H.district_id as dh,
                                 H.upazila_id as uh, H.phone as ph, DC.* 
                                 FROM `DOCTOR_CHAMBERS` DC JOIN HOSPITALS H 
                                 ON DC.hospital_id = H.row_id WHERE DC.doctor_id = $doctorId");

    if($queryResult->num_rows > 0){
       while($row = $queryResult->fetch_assoc()){
           $result[] = $row;
       }
    }
    
    return $result;
}

function getAmbulanceEditData($user, $rowId){
    
    $conn = createSqlConnection();
    
    $query = "SELECT * FROM AMBULANCE WHERE row_id = $rowId";
    $result = $conn->query($query);
    $dataFound = $result->num_rows > 0;

    if($dataFound){
        $row = $result->fetch_assoc();
        
        echo json_encode(['success' => true, 'response' => json_encode($row)]);
    }else{
        echo json_encode(['success' => false, 'errcode' => $GLOBALS['ERROR_NO_DATA_FOUND'], 'response' => "No data found in this service"]);
    }
}



function getFireData(){
    
    $conn = createSqlConnection();
    
    $query = "SELECT * FROM FIRE_SERVICE WHERE visibility = 1";
    $result = $conn->query($query);
    $dataFound = $result->num_rows > 0;

    if($dataFound){
        $resultData = null;
        while ($row = $result->fetch_assoc()) {
            $resultData[] = $row;
        }
        
        echo json_encode(['success' => true, 'response' => json_encode($resultData)]);
    }else{
        noDataFound();
    }
}

function getPoliceData(){
    $conn = createSqlConnection();
    
    $query = "SELECT * FROM POLICE WHERE visibility = 1";
    $result = $conn->query($query);
    $dataFound = $result->num_rows > 0;

    if($dataFound){
        $resultData = null;
        while ($row = $result->fetch_assoc()) {
            $resultData[] = $row;
        }
        
        echo json_encode(['success' => true, 'response' => json_encode($resultData)]);
    }else{
        noDataFound();
    }
}


function updateViewCount($service, $rowId){
    $conn = createSqlConnection();
    
    $query = "SELECT * FROM SERVICES WHERE service = $service";
    $result = $conn->query($query);
    $dataFound = $result->num_rows > 0;

    if($dataFound){
        $row = $result->fetch_assoc();
        $tableName = $row['table_name'];
        
        $stmt = $conn->prepare("UPDATE $tableName SET clicks = clicks + 1 WHERE row_id = ?");
        $stmt->bind_param('i', $rowId);
        $stmt->execute();
    }
}

function enableDisableService(){
    $conn = createSqlConnection();
    
    $service = $_POST['service_type'];
    $state = $_POST['state'];
    
    
    $query = "SELECT * FROM SERVICES WHERE service = $service";
    $result = $conn->query($query);
    $dataFound = $result->num_rows > 0;

    if($dataFound){
        $row = $result->fetch_assoc();
        $tableName = $row['table_name'];
        
        $stmt = $conn->prepare("UPDATE $tableName SET enabled = $state WHERE row_id = ?");
        $stmt->bind_param('i', $rowId);
        $stmt->execute();

        if($getResponse){
            if($conn->affected_rows > 0){
                echo json_encode(['success' => true, 'response' => "Changed state to $state"]);
            }else {
                echo json_encode(['success' => false, 'errcode' => 343, 'response' => "No row found with id '$rowId' on table '$tableName'"]);
            }
        }
    }
}










?>