<?php

include("sqlconn.php");

$REQUEST_UPDATE_CLICKS = 9;
$REQUEST_GET_SERVICE = 10;
$REQUEST_ADD_SERVICE = 11;
$REQUEST_UPDATE_SERVICE = 16;
$REUQEST_UPDATE_SERVICE = 16;
$REQUEST_GET_SERVICE_LIST = 12;
$REQUEST_GET_ADDABLE_SERVICE_LIST = 13;
$REQUEST_GET_EDIT_SERVICE = 14;
$REQUEST_GET_SERVICE_DETAILS = 15;
$REQUEST_UPDATE_SERVICE_STATE = 19;

$SERVICE_TYPE_BLOOD_DONOR = 104;
$SERVICE_TYPE_TUITION = 106;
$SERVICE_TYPE_AMBULANCE = 105;
$SERVICE_TYPE_FIRE = 107;
$SERVICE_TYPE_POLICE = 109;
$SERVICE_TYPE_MECHANICS = 112;
$SERVICE_TYPE_BUY_SELL = 123;
$SERVICE_TYPE_RENT = 122;
$SERVICE_TYPE_HOSPITAL = 100;
$SERVICE_TYPE_EDU_INST = 102; //EDUCATION INSTITUTES
$SERVICE_TYPE_DOCTOR = 101;

$ERROR_NO_DATA_FOUND = 114;
$ERROR_TYPE_DATA_ADD = 221;

$requestType = $_POST['request'] ?? 0;
if($requestType != 0){

    if($requestType == $REQUEST_ADD_SERVICE){
        postOrAddService();
    }else if($requestType == $REQUEST_UPDATE_SERVICE){
        updateService();
    }else if($requestType == $REQUEST_UPDATE_SERVICE_STATE){
        enableDisableService();
    }else if($requestType == $REQUEST_UPDATE_CLICKS){
        $service = $_POST['service_type'];
        $row_id = $_POST['row_id'];
        updateViewCount($service, $row_id);
    }
}


function postOrAddService(){
    $conn = createSqlConnection();
    $conn->set_charset('utf8mb4');
    
    $user = $_POST['uuid'];
    $serviceType = $_POST['service_type'];
    $insertData = null;
    
    if($serviceType == $GLOBALS['SERVICE_TYPE_TUITION']){
        $postData = json_decode($_POST['post_data'], true);
        $eduData = $postData['edu_data'];
        $type = $postData['tuition_type'];
        
        $insertData = $conn->prepare("INSERT INTO TUITION_POSTS (`user`, `type`, education_data, visibility) VALUES (?, ?, ?, 1)");
        $insertData->bind_param("sis", $user, $type, $eduData);
        
    }else if($serviceType == $GLOBALS['SERVICE_TYPE_AMBULANCE']){
        $postData = json_decode($_POST['post_data'], true);

        $insertData = $conn->prepare("INSERT INTO AMBULANCE (`user`, title, proprietor, phone, location_name, service_area, district, upazila, `union`, hospital_id) VALUES (?, ?, ?, ?, ?, ?, ?, ?, ?, ?)");
        $insertData->bind_param("ssssssiiii", $user, $postData['title'], $postData['proprietor'], $postData['phone'], $postData['road'], $postData['service_area'], $postData['district_id'], $postData['upazila_id'], $postData['union_id'], $postData['hospital_id']);
    }else if($serviceType == $GLOBALS['SERVICE_TYPE_EDU_INST']){
        $postData = json_decode($_POST['post_data'], true);

        $category = $postData['category'];
        
        $insertData = $conn->prepare("INSERT INTO EDU_INSTITUTES (`user`, name, principal_name, official, email, website, phone, category, established_year, location_name, district_id, upazila_id, union_id, student_total, eiin, logo) VALUES(?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?)");
        $insertData->bind_param("sssisssiisiiiiis", $user, $postData['name'], $postData['principal'], $postData['official'], $postData['email'], $postData['website'], $postData['phone'], $category, $postData['est_year'], $postData['road'], $postData['district_id'], $postData['upazila_id'], $postData['union_id'], $postData['students'], $postData['eiin'], $postData['logo_name']);
    }else if($serviceType == $GLOBALS['SERVICE_TYPE_MECHANICS']){
        $postData = json_decode($_POST['post_data'], true);

        $source = $postData['source'];
        if($source == 1){//Add for another user
            $insertData = $conn->prepare("INSERT INTO MECHANICS (`user`, name, phone, location_name, district_id, upazila_id, union_id, experience, source, category, image_name) VALUES (?, ?, ?, ?, ?, ?, ?, ?, 1, ?, ?)");
            
            $insertData->bind_param("ssssiiisis", $user, $postData['name'], $postData['phone'], $postData['road'], $postData['district_id'], $postData['upazila_id'], $postData['union_id'], $postData['experience'], $postData['category'], $postData['image_name']);
            
        }else{//Add for self
            $insertData = $conn->prepare("INSERT INTO MECHANICS (`user`, experience, category, phone) VALUES (?, ?, ?, ?)");
            $insertData->bind_param("ssis", $user, $postData['experience'], $postData['category'], $postData['addt_phone']);
        }
    }else if($serviceType == $GLOBALS['SERVICE_TYPE_BUY_SELL']){
        $postData = json_decode($_POST['post_data'], true);
        
        $time = microtime(true);
        $fixed = $postData['fixed'];
        $insertData = $conn->prepare("INSERT INTO PRODUCTS (`user`, title, phone, phone_has_wa, brand, product_condition, 
                                        description, price, price_fixed, images, location_name, district_id, upazila_id, 
                                        union_id, category, post_time, update_time) 
                                        VALUES (?, ?, ?, ?, ?, ?, ?, ?, $fixed, ?, ?, ?, ?, ?, ?, ?)");
        $insertData->bind_param("sssisisissiiiiii", $user, $postData['title'], $postData['phone'], 
                                $postData['has_whatsapp'], $postData['brand'], $postData['condition'],
                                $postData['desc'], $postData['price'], $postData['images'], $postData['road'], 
                                $postData['district_id'], $postData['upazila_id'], $postData['union_id'],
                                $postData['category'], $time, $time);
        
    }else if($serviceType == $GLOBALS['SERVICE_TYPE_BLOOD_DONOR']){
        $postData = json_decode($_POST['post_data'], true);
        
        $insertData = $conn->prepare("INSERT INTO BLOOD_DONORS (`user`, last_donate, visibility) VALUES(?, ?, 1)");
        $insertData->bind_param("si", $user, $postData['last_donate']);
    }else if($serviceType == $GLOBALS['SERVICE_TYPE_HOSPITAL']){
        
        $postData = json_decode($_POST['post_data'], true);
        $logoName = $postData['logo_name'] ?? "";
        
        $insertData = $conn->prepare("INSERT INTO HOSPITALS (`user`, name, phone, email, website, 
                                        est_year, official, timing, sit_count, room_count, logo, 
                                        district_id, upazila_id, union_id, location_name, category, about,
                                        visibility) VALUES(?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, 1)");
                                        
        $insertData->bind_param("sssssiisiisiiisis", $user, $postData['name'], $postData['phone'],
                                $postData['email'], $postData['website'], $postData['est_year'], 
                                $postData['official'], $postData['timing'], $postData['sits'],
                                $postData['rooms'], $logoName, $postData['district'],
                                $postData['upazila'], $postData['union'], $postData['road'], 
                                $postData['category'], $postData['about']);
    }else if($serviceType == $GLOBALS['SERVICE_TYPE_DOCTOR']){
        
        $postData = json_decode($_POST['post_data'], true);
        $logoName = $postData['logo_name'] ?? "";
        
        $insertData = $conn->prepare("INSERT INTO DOCTORS (`user`, name, phone, email, image_name, road, qualifications,
                                        description, category, district_id, upazila_id, union_id) 
                                        VALUES(?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?)");
                                        
        $insertData->bind_param("ssssssssiiii", $user, $postData['name'], $postData['phone'], 
                                $postData['email'], $logoName, $postData['road'],
                                $postData['qualifications'], $postData['desc'], $postData['category'],
                                $postData['district'], $postData['upazila'], $postData['union']);
    }else if($serviceType == $GLOBALS['SERVICE_TYPE_RENT']){
        $postData = json_decode($_POST['post_data'], true);
        
        $time = microtime(true);
        $insertData = $conn->prepare("INSERT INTO RENTS (`user`, title, phone, phone_has_wa, description, rent, 
                                        rent_type, images, location_name, district_id, upazila_id, 
                                        union_id, category, post_time, update_time) 
                                        VALUES (?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?)");
        $insertData->bind_param("sssisiissiiiiii", $user, $postData['title'], $postData['phone'], 
                                $postData['has_whatsapp'], $postData['desc'], $postData['rent'], $postData['rent_type'], 
                                $postData['images'], $postData['road'], $postData['district_id'],
                                $postData['upazila_id'], $postData['union_id'], $postData['category'], $time, $time);
        
    }
    
    $result = $insertData->execute();

    if($result && $conn->affected_rows > 0){
        $addedId = $conn->insert_id;
        
        if($serviceType == $GLOBALS['SERVICE_TYPE_DOCTOR']){
            $postData = json_decode($_POST['post_data'], true);
            $chamberData = json_decode($postData['chambers'], true);
            
            addUpdateRemoveChamber($conn, $chamberData, $addedId);
        }
        
        echo json_encode(['success' => true, 'response' => "Data added successfully", 'added_id' => $addedId]);
        //Echo success
    }else{
        echo json_encode(['success' => false, 'errcode' => $GLOBALS['ERROR_TYPE_DATA_ADD'], 'response'=> "Failed to add data."]);
        //Echo failed
    }
}


function updateService(){
    $rowId = $_POST['row_id'];
    
    if($rowId == -1){
        postOrAddService();
        return;
    }
    
    $conn = createSqlConnection();
    $conn->set_charset('utf8mb4');
    
    $user = $_POST['uuid'];
    $serviceType = $_POST['service_type'];
    $updateData = null;
    
    if($serviceType == $GLOBALS['SERVICE_TYPE_TUITION']){
        $postData = json_decode($_POST['post_data'], true);
        $eduData = $postData['edu_data'];
        $type = $postData['tuition_type'];
        
        $updateData = $conn->prepare("UPDATE TUITION_POSTS SET `type` = ?, education_data = ? WHERE row_id = $rowId AND user = '$user'");
        $updateData->bind_param("is", $type, $eduData);
        
    }else if($serviceType == $GLOBALS['SERVICE_TYPE_AMBULANCE']){
        $postData = json_decode($_POST['post_data'], true);

        $updateData = $conn->prepare("UPDATE AMBULANCE SET title = ?, proprietor = ?, phone = ?, location_name = ?, service_area = ?, district = ?, upazila = ?, `union` = ?, hospital_id = ? WHERE row_id = $rowId AND user = '$user'");
        $updateData->bind_param("sssssiiii", $postData['title'], $postData['proprietor'], $postData['phone'], $postData['road'], $postData['service_area'], $postData['district_id'], $postData['upazila_id'], $postData['union_id'], $postData['hospital_id']);
        
    }else if($serviceType == $GLOBALS['SERVICE_TYPE_EDU_INST']){
        $postData = json_decode($_POST['post_data'], true);

        $category = $postData['category'];
        
        $logoName = $postData['logo_name'] ?? "";
        $unionId = 0;
        
        $tableName = "EDU_INSTITUTES";
        
        $updateData = $conn->prepare("UPDATE $tableName SET name = ?, principal_name = ?, official = ?, email = ?, website = ?, phone = ?, category = ?, established_year = ?, location_name = ?, district_id = ?, upazila_id = ?, union_id = ?, student_total = ?, eiin = ?, logo = ? WHERE row_id = $rowId AND user = '$user'");
        $updateData->bind_param("ssisssiisiiiiis", $postData['name'], $postData['principal'], 
                                $postData['official'], $postData['email'], $postData['website'], 
                                $postData['phone'], $category, $postData['est_year'], $postData['road'], 
                                $postData['district_id'], $postData['upazila_id'], $unionId, 
                                $postData['students'], $postData['eiin'], $logoName);
        
    }else if($serviceType == $GLOBALS['SERVICE_TYPE_MECHANICS']){
        $postData = json_decode($_POST['post_data'], true);

        $source = $postData['source'];
        if($source == 1){//Update for other users
            $updateData = $conn->prepare("UPDATE MECHANICS SET name = ?, phone = ?, location_name = ?, district_id = ?, upazila_id = ?, union_id = ?, experience = ?, source = 1, category = ? WHERE row_id = $rowId AND user = '$user'");
            
            $updateData->bind_param("sssiiisi", $postData['name'], $postData['addt_phone'], $postData['road'], $postData['district_id'], $postData['upazila_id'], $postData['union_id'], $postData['experience'], $postData['category']);
        }else{//Update for self
            $updateData = $conn->prepare("UPDATE MECHANICS SET experience = ?, phone = ?, category = ? WHERE row_id = ? AND user = '$user'");
            $updateData->bind_param("ssii", $postData['experience'], $postData['addt_phone'], $postData['category'], $rowId);
        }
    }else if($serviceType == $GLOBALS['SERVICE_TYPE_BLOOD_DONOR']){
        $postData = json_decode($_POST['post_data'], true);
        
        $updateData = $conn->prepare("UPDATE BLOOD_DONORS SET last_donate = ? WHERE row_id = $rowId AND user = '$user'");
        $updateData->bind_param("i", $postData['last_donate']);
    }else if($serviceType == $GLOBALS['SERVICE_TYPE_HOSPITAL']){
        
        $postData = json_decode($_POST['post_data'], true);
        $logoName = $postData['logo_name'] ?? "";
        
        $updateData = $conn->prepare("UPDATE HOSPITALS SET name = ?, phone = ?, email = ?, website = ?, 
                                        est_year = ?, official = ?, timing = ?, sit_count = ?, room_count = ?, 
                                        logo = ?, district_id = ?, upazila_id = ?, union_id = ?, location_name = ?,
                                        category = ?, about = ? WHERE row_id = $rowId AND user = '$user'");
                                        
        $updateData->bind_param("ssssiisiisiiisis", $postData['name'], $postData['phone'],
                                $postData['email'], $postData['website'], $postData['est_year'], 
                                $postData['official'], $postData['timing'], $postData['sits'],
                                $postData['rooms'], $logoName, $postData['district'],
                                $postData['upazila'], $postData['union'], $postData['road'],
                                $postData['category'], $postData['about']);
    }else if($serviceType == $GLOBALS['SERVICE_TYPE_DOCTOR']){
        
        $postData = json_decode($_POST['post_data'], true);
        $logoName = $postData['logo_name'] ?? "";
        
        $updateData = $conn->prepare("UPDATE DOCTORS SET name = ?, phone = ?, email = ?, image_name = ?,
                                        road = ?, qualifications = ?, description = ?, category = ?,
                                        district_id =?, upazila_id = ?, union_id = ? WHERE row_id = $rowId AND user = '$user'");
                                        
        $updateData->bind_param("sssssssiiii", $postData['name'], $postData['phone'], 
                                $postData['email'], $logoName, $postData['road'],
                                $postData['qualifications'], $postData['desc'], $postData['category'],
                                $postData['district'], $postData['upazila'], $postData['union']);
                                
    }else if($serviceType == $GLOBALS['SERVICE_TYPE_BUY_SELL']){
        $postData = json_decode($_POST['post_data'], true);
        
        $time = microtime(true);
        $fixed = $postData['fixed'];
        $updateData = $conn->prepare("UPDATE PRODUCTS SET title = ?, phone = ?, phone_has_wa = ?, 
                                    brand = ?, product_condition = ?, description = ?, price = ?, 
                                    price_fixed = ?, location_name = ?, district_id = ?, upazila_id = ?,
                                    union_id = ?, category = ?, update_time = ? WHERE row_id = $rowId");
                                    
        $updateData->bind_param("ssisisiisiiiii", $postData['title'], $postData['phone'], 
                                $postData['has_whatsapp'], $postData['brand'], $postData['condition'], 
                                $postData['desc'], $postData['price'], $fixed, $postData['road'], $postData['district_id'], 
                                $postData['upazila_id'], $postData['union_id'], $postData['category'], $time);
        
    }
    
    $result = $updateData->execute();
    
    if($serviceType == $GLOBALS['SERVICE_TYPE_DOCTOR']){
        $postData = json_decode($_POST['post_data'], true);
        $chamberData = json_decode($postData['chambers'], true);
        
        $affectedUpdate = addUpdateRemoveChamber($conn, $chamberData, $rowId);
        
        if($affectedUpdate == true){
            echo json_encode(['success' => true, 'response' => "Data updated successfully"]);
        }else{
            echo json_encode(['success' => false, 'errcode' => $GLOBALS['ERROR_TYPE_DATA_ADD'], 'response'=> "Failed to update data."]);
            //Echo failed
        }
        return;
    }
    if($result && $conn->affected_rows > 0){
        echo json_encode(['success' => true, 'response' => "Data updated successfully"]);
        //Echo success
    }else{
        echo json_encode(['success' => false, 'errcode' => $GLOBALS['ERROR_TYPE_DATA_ADD'], 'response'=> "Failed to update data."]);
        //Echo failed
    }
}

function addUpdateRemoveChamber($conn, $chamberArray, $doctorId){
    $updated = false;
    
    foreach($chamberArray as $chamber){
        $chamber = json_decode($chamber, true);
        
        $hospitalId = $chamber['hospital_id'];
        $timingData = json_encode($chamber['timing']);

        $chamberId = $chamber['row_id'] ?? -1;
        $deleteChamber = $chamber['deleted'] ?? false;
        
        $preparedData = null;
        if($chamberId == -1){
            $preparedData = $conn->prepare("INSERT INTO DOCTOR_CHAMBERS (hospital_id, doctor_id, timing) VALUES (?, ?, ?)");
        }else if($deleteChamber){
            $conn->query("DELETE FROM DOCTOR_CHAMBERS WHERE row_id = $chamberId");
        }else{
            $preparedData = $conn->prepare("UPDATE DOCTOR_CHAMBERS SET hospital_id = ?, doctor_id = ?, timing = ? WHERE row_id = $chamberId");
        }
        
        if($preparedData != null){
            $preparedData->bind_param("iis", $hospitalId, $doctorId, $timingData);
            $preparedData->execute();
        }
        
        
        if($conn->affected_rows > 0){
            $updated = true;
        }
    }
    
    return $updated;
}

function updateChamber($conn, $chamberArray, $doctorId){
    
    foreach($chamberArray as $chamber){
        $chamber = json_decode($chamber, true);
        
        $hospitalId = $chamber['hospital_id'];
        $chamberId = $chamber['row_id'];
        $timingData = $chamber['timing'];
        
        $insertData = $conn->prepare("UPDATE DOCTOR_CHAMBERS SET hospital_id = ?, timing = ? WHERE row_id = ?");
        $insertData->bind_param("isi", $hospitalId, $timingData, $chamberId);
        $insertData->execute();
    }
}

function updateViewCount($service, $rowId){
    $conn = createSqlConnection();
    
    $query = "SELECT * FROM SERVICES WHERE service = $service";
    $result = $conn->query($query);
    $dataFound = $result->num_rows > 0;

    if($dataFound){
        $row = $result->fetch_assoc();
        $tableName = $row['table_name'];
        
        $stmt = $conn->prepare("UPDATE $tableName SET clicks = clicks + 1 WHERE row_id = ?");
        $stmt->bind_param('i', $rowId);
        $stmt->execute();

        if($conn->affected_rows > 0){
            echo json_encode(['success' => true, 'response' => "Updated 1 view or click"]);
        }else {
            echo json_encode(['success' => false, 'errcode' => 343, 'response' => "No row found with id '$rowId' on table '$tableName'"]);
        }
    
    }
}

function enableDisableService(){
    $conn = createSqlConnection();
    
    $service = $_POST['service_type'];
    $state = $_POST['state'];
    $rowId = $_POST['row_id'];
    $uuid = $_POST['uuid'];
    
    $query = "SELECT * FROM SERVICES WHERE service = $service";
    $result = $conn->query($query);
    $dataFound = $result->num_rows > 0;

    if($dataFound){
        $row = $result->fetch_assoc();
        $tableName = $row['table_name'];
        
        $stmt = $conn->prepare("UPDATE $tableName SET enabled = $state WHERE row_id = ? AND user = '$uuid'");
        $stmt->bind_param('i', $rowId);
        $stmt->execute();

        if($conn->affected_rows > 0){
            echo json_encode(['success' => true, 'response' => "Changed state to $state"]);
        }else {
            echo json_encode(['success' => false, 'errcode' => 343, 'response' => "No row found with id '$rowId' on table '$tableName'"]);
        }
    
    }
}

?>