<?php
include 'crypto.php';
include 'sqlconn.php';

$ERROR_BANNED = 108;
$ERROR_OTP_MISMATCH = 113;

$ACCOUNT_CREATE_REQUEST = 8;

if($_POST['request'] == $ACCOUNT_CREATE_REQUEST){
    $phone = $_POST['userPhone'];
    $fullName = $_POST['fullName'];
    $password = $_POST['password'];
    $otp = $_POST['otp'];
    
    registerAccount($fullName, $phone, $password, $otp);
}

// echo filesize("php://input");
// echo json_decode(file_get_contents("php://input"), true)['k1'];

function registerAccount($name, $phone, $pass, $otp){
    if($name === null || $phone === null || $pass === null || $otp === null){
        die("Failed: Invalid sign up data");
    }
    
    $conn = createSqlConnection();
    $conn->set_charset("utf8");
    
    if(!isValidOTP($conn, $phone, $otp)){
        echo json_encode(['success' => false, 'errcode'=>$GLOBALS['ERROR_OTP_MISMATCH'], 'response'=>"Invalid OTP Code"]);
        return;
    }
    if(isAccountExists($conn, $phone)){
        echo json_encode(['success' => false, 'errcode' => $GLOBALS['ERROR_ALREADY_EXISTS'], 'response' => "Account already exists"]);
        return;
    }
    
    $timestamp = round(microtime(true) * 1000);

    $insertData = $conn->prepare("INSERT INTO USERS (full_name, phone, password, joined_millis) VALUES (?, ?, ?, ?)");
    
    $hashedPass = hash('sha256', $pass);
    $insertData->bind_param("sssi", $name, $phone, $hashedPass, $timestamp);

    $result = $insertData->execute();

    if ($result) {
        
        $inserted_id = $conn->insert_id;
        
        $select_query = "SELECT * FROM USERS WHERE row_id = $inserted_id";
        $result = $conn->query($select_query);
        
        $dataAdded = $result->num_rows > 0;
        
        if($dataAdded){
            echo json_encode(['success' => true, 'response' => 'Signed up successfully']);
        }else{
            echo json_encode(['success' => false, 'errcode' => 0x00, 'response' => "Info not added to database"]);
        }
    } else {
        echo json_encode(['success' => false, 'message' => $conn->error]);
    }
}


function isAccountExists($conn, $phone){
    $select_query = "SELECT * FROM USERS WHERE phone = '$phone'";
    $result = $conn->query($select_query);
    return $result->num_rows > 0;
}

function isValidOTP($conn, $phone, $otp){
    $select_query = "SELECT * FROM OTP WHERE phone = '$phone'";
    $result = $conn->query($select_query);
    
    if($result->num_rows>0){
        $data = [];
        while ($row = $result->fetch_assoc()) {
            $data = $row;
        }
        
        if($otp == $data['valid_otp']){
            return true;
        }else return false;
    }else false;
}

?>