<?php

include("crypto.php");

$REQUEST_UPDATE_CLICKS = 9;
$REQUEST_GET_SERVICE = 10;
$REQUEST_ADD_SERVICE = 11;
$REQUEST_UPDATE_SERVICE = 16;
$REUQEST_UPDATE_SERVICE = 16;
$REQUEST_GET_SERVICE_LIST = 12;
$REQUEST_GET_ADDABLE_SERVICE_LIST = 13;
$REQUEST_GET_EDIT_SERVICE = 14;
$REQUEST_GET_SERVICE_DETAILS = 15;

$SERVICE_TYPE_BLOOD_DONOR = 104;
$SERVICE_TYPE_TUITION = 106;
$SERVICE_TYPE_AMBULANCE = 105;
$SERVICE_TYPE_FIRE = 107;
$SERVICE_TYPE_POLICE = 109;
$SERVICE_TYPE_MECHANICS = 112;
$SERVICE_TYPE_BUY_SELL = 123;
$SERVICE_TYPE_HOSPITAL = 100;
$SERVICE_TYPE_EDU_INST = 102; //EDUCATION INSTITUTES

$ERROR_NO_DATA_FOUND = 114;
$ERROR_TYPE_DATA_ADD = 221;

$requestType = $_POST['request'] ?? $_GET['request'] ?? 0;
if($requestType != 0){

    if($requestType == $REQUEST_GET_SERVICE_LIST){
        $data = json_decode(file_get_contents("php://input"), true);
        $localeCode = $data['locale'];
        getServiceList($localeCode, $data['version_code']);
    }else if($requestType == $REQUEST_GET_ADDABLE_SERVICE_LIST){
        $data = json_decode(file_get_contents("php://input"), true);
        $localeCode = $data['locale'];
        getAddableServiceList($localeCode, $data['version_code']);
    }else if($requestType == $REQUEST_GET_SERVICE){
        $data = json_decode(file_get_contents("php://input"), true);
        $serviceType = $data['service_type'];
        $basicsOnly = array_key_exists("basics_only", $data) ? $data['basics_only']: false;
        $username = $basicsOnly ? $data['username'] : null;
        
        if($serviceType == $SERVICE_TYPE_BLOOD_DONOR){
            getBloodDonorList();
        }else if($serviceType == $SERVICE_TYPE_TUITION){
            getTuitionData();
        }else if($serviceType == $SERVICE_TYPE_AMBULANCE){
            getAmbulanceData($basicsOnly, $username);
        }else if($serviceType == $SERVICE_TYPE_FIRE){
            getFireData();
        }else if($serviceType == $SERVICE_TYPE_POLICE){
            getPoliceData();
        }else if($serviceType == $SERVICE_TYPE_EDU_INST){
            getEduData($data['sub_category'] ?? 0, $basicsOnly, $username);
        }else if($serviceType == $SERVICE_TYPE_HOSPITAL){
            getHospital($data['sub_category'] ?? 0, $basicsOnly, $username);
        }else if($serviceType == $SERVICE_TYPE_MECHANICS){
            getMechanics($basicsOnly, $username, $data['sub_category'] ?? 0);
        }else if($serviceType == $SERVICE_TYPE_BUY_SELL){
            getProducts($username, $data['sub_category']);
        }else{
            noDataFound();
        }
    }else if($requestType == $REQUEST_GET_EDIT_SERVICE){
        $data = json_decode(file_get_contents("php://input"), true);
        $serviceType = $data['service_type'];
        $username = $data['username'];
        $rowId = $data['row_id'];

        if($serviceType == $SERVICE_TYPE_TUITION){
            getTuitionForEdit($username);
        }else if($serviceType == $SERVICE_TYPE_AMBULANCE){
            getAmbulanceEditData($username, $rowId);
        }else if($serviceType == $SERVICE_TYPE_MECHANICS){
            getMechanicsForEdit(true, $username);
        }else if($serviceType == $SERVICE_TYPE_EDU_INST){
            getEduForEdit($serviceType, $rowId);
        }else if($serviceType == $SERVICE_TYPE_BLOOD_DONOR){
            getBloodDonorForEdit($username);
        }else if($serviceType == $SERVICE_TYPE_HOSPITAL){
            getHospitalForEdit($rowId, $username);
        }else{
            noDataFound();
        }
    }else if($requestType == $REQUEST_ADD_SERVICE){
        postOrAddService();
    }else if($requestType == $REQUEST_UPDATE_SERVICE){
        updateService();
    }else if($requestType == $REQUEST_GET_SERVICE_DETAILS){
        $data = json_decode(file_get_contents("php://input"), true);
        $serviceType = $data['service_type'];
        $rowId = $data['row_id'];
        
        $isEducation = $serviceType == $SERVICE_TYPE_EDU_INST;
        
        if($isEducation){
            getEduDetails($serviceType, $rowId);
        }else if($serviceType == $SERVICE_TYPE_BUY_SELL){
            getProductDetails($rowId);
        }else if($serviceType == $SERVICE_TYPE_HOSPITAL){
            getHealthInstDetails($rowId);
        }
        
    }else if($requestType == $REQUEST_UPDATE_CLICKS){
        $service = $_POST['service_type'];
        $row_id = $_POST['row_id'];
        updateViewCount($service, $row_id);
    }
}

function noDataFound(){
    echo json_encode(['success' => false, 'errcode' => $GLOBALS['ERROR_NO_DATA_FOUND'], 'response' => "No data found"]);
}
function getServiceList($localeCode, $appVersion){
    $conn = createSqlConnection();
    $conn->set_charset('utf8');
    
    $query = "SELECT * FROM SERVICES ORDER BY sn";
    $result = $conn->query($query);
    $dataFound = $result->num_rows > 0;

    if($dataFound){
        $data = null;
        while ($row = $result->fetch_assoc()) {
            $requiredVersion = $row['required_version'];
            if($requiredVersion <= $appVersion && $row['enabled'] == true){
                $name = $localeCode === "en" ? $row['en_name'] : $row['name'];
                
                $data[] = ['name' => $name, 'service' => $row['service'], 'category' => $row['category'], 'icon_url' => $row['icon']];
            }
        }
        
        echo json_encode(['success' => true, 'response' => $data]);
    }
}

function getAddableServiceList($localeCode, $appVersion){
    $conn = createSqlConnection();
    $conn->set_charset('utf8');
    
    $query = "SELECT * FROM SERVICES ORDER BY sn";
    $result = $conn->query($query);
    $dataFound = $result->num_rows > 0;

    if($dataFound){
        $data = null;
        $resultData = null;
        while ($row = $result->fetch_assoc()) {
            $requiredVersion = $row['required_version'];
            if($requiredVersion <= $appVersion && $row['has_access'] == true){
                $name = $localeCode === "en" ? $row['en_name'] : $row['name'];
                
                $data[] = ['name' => $name, 'service' => $row['service'], 'category' => $row['category'], 'icon_url' => $row['icon'], 'enabled' => $row['enabled']];
            }
        }
        
        echo json_encode(['success' => true, 'response' => $data]);
    }
}


function getBloodDonorList(){
    $conn = createSqlConnection();
    $conn->set_charset('utf8');
    
    $query = "SELECT bd.row_id as id, bd.last_donate, bd.clicks, bd.total_donate as donate_count,
              u.full_name as name, u.blood_group, u.village, u.district, u.upazila,
              u.`union`, u.pp_url as avatar_url FROM BLOOD_DONORS bd JOIN USERS u 
              ON bd.user = u.username WHERE bd.enabled = 1";
              
    $result = $conn->query($query);
    $dataFound = $result->num_rows > 0;

    if($dataFound){
        $data = null;
        $resultData = null;
        while ($row = $result->fetch_assoc()) {
            // $data[] = $row;
            // $name = $row['full_name'];
            // $group = $row['blood_group'];
            // $address = $row['village'];
            // $avatar = $row['pp_url'];
            // $row_id = $row['row_id'];
            // $last_donate = $row['last_donate'];
            // $totalDonate = $row['total_donate'];
            // $available = true;
            
            $resultData[] = $row;
        }
        echo json_encode(['success' => true, 'response' => json_encode($resultData)]);
    }else{
        noDataFound();
    }
}


function getBloodDonorForEdit($user){
    $conn = createSqlConnection();
    $conn->set_charset('utf8');
    
    $query = "SELECT row_id, last_donate, enabled FROM BLOOD_DONORS WHERE user = '$user'";
              
    $result = $conn->query($query);
    $dataFound = $result->num_rows > 0;

    if($dataFound){
        $row = $result->fetch_assoc();
        $row['enabled'] = $row['enabled'] == 1;
        echo json_encode(['success' => true, 'response' => json_encode($row)]);
    }else{
        noDataFound();
    }
}


function getTuitionData(){
        $conn = createSqlConnection();
    $conn->set_charset('utf8');
    
$query = "SELECT TUITION_POSTS.*,
          USERS.full_name, USERS.village, USERS.pp_url, 
          USERS.gender, USERS.phone
          FROM TUITION_POSTS 
          JOIN USERS ON TUITION_POSTS.user = USERS.username 
          WHERE TUITION_POSTS.visibility = 1";

    $result = $conn->query($query);
    $dataFound = $result->num_rows > 0;

    if($dataFound){
        $data = null;
        $resultData = null;
        while ($row = $result->fetch_assoc()) {
            $name = $row['full_name'];
            $address = $row['village'];
            $avatar = $row['pp_url'];
            $gender = $row['gender'];
            $phone = $row['phone'];
            $education = $row['education_data'];
            $type = $row['type'];
            $clicks = $row['clicks'];
            $rowId = $row['row_id'];
            
            
            $resultData[] = ['row_id' => $rowId, 'name' => $name, 'gender' => $gender, 'address' => $address, 'avatar_url' => $avatar, 'education' => $education, 'phone' => $phone, 'clicks' => $clicks];
        }
        echo json_encode(['success' => true, 'response' => json_encode($resultData)]);
    }else{
        noDataFound();
    }
}


function getTuitionForEdit($user){
    
    $conn = createSqlConnection();
    $conn->set_charset('utf8');
    
    $query = "SELECT * FROM TUITION_POSTS WHERE user = '$user'";

    $result = $conn->query($query);
    $dataFound = $result->num_rows > 0;

    if($dataFound){
        $row = $result->fetch_assoc();
        
        $row['enabled'] = $row['enabled'] == 1;
        echo json_encode(['success' => true, 'response' => json_encode($row)]);
    }else{
        noDataFound();
    }
}


function getAmbulanceData($basicOnly, $user){
    
    $conn = createSqlConnection();
    $conn->set_charset('utf8');
    
    //For public
    $query = "SELECT * FROM AMBULANCE WHERE visibility = 1";
    if($basicOnly){
        //For editor
        $query = "SELECT * FROM AMBULANCE WHERE user = '$user'";
    }
    
    $result = $conn->query($query);
    $dataFound = $result->num_rows > 0;

    if($dataFound){
        $resultData = null;
        while ($row = $result->fetch_assoc()) {
            
            if($basicOnly){
                $resultData[] = ['row_id' => $row['row_id'], 'title' => $row['title'], 'subtitle' => $row['proprietor'], 'status' => $row['visibility'], 'image' => "https://cdn.minidevbd.com/m/p/icons/ambulance-128.png"];
                continue;
            }
            
            $rowId = $row['row_id'];
            $title = $row['title'];
            $proprietor = $row['proprietor'];
            
            $districtId = $row['district'];
            $upazilaId = $row['upazila'];
            $unionId = $row['union'];
            $road = $row['location_name'];
            
            $phone = $row['phone'];
            $clicks = $row['clicks'];
            $coveredArea = $row['service_area'];
            
            $resultData[] = ['row_id' => $rowId, 'title' => $title, 'area' => $coveredArea, 'road' => $road, 'district_id' => $districtId, 'upazila_id' => $upazilaId, 'union_id' => $unionId, 'proprietor' => $proprietor, 'phone' => $phone, 'clicks' => $clicks];
        
        }
        
        echo json_encode(['success' => true, 'response' => json_encode($resultData)]);
    }else{
        noDataFound();
    }
}


function getMechanics($basicOnly, $user, $subCategory){
    
    $conn = createSqlConnection();
    $conn->set_charset('utf8');
    
    //For public
    $query = "SELECT MECHANICS.*, USERS.full_name,
             USERS.district, USERS.upazila, USERS.`union`,
             USERS.village, USERS.phone, USERS.pp_url
             FROM MECHANICS JOIN USERS ON MECHANICS.user = USERS.username WHERE MECHANICS.visibility = 1 AND MECHANICS.category = $subCategory";
    if($basicOnly){
        //For editor
        $query = "SELECT * FROM MECHANICS WHERE user = '$user'";
    }
    
    $result = $conn->query($query);
    $dataFound = $result->num_rows > 0;

    if($dataFound){
        $resultData = null;
        $data = null;
        
        while ($row = $result->fetch_assoc()) {
            // if($basicOnly){
            //     $resultData[] = ['row_id' => $row['row_id'], 'title' => $row['title'], 'subtitle' => $row['proprietor'], 'status' => $row['visibility'], 'image' => "https://cdn.minidevbd.com/m/p/icons/ambulance-128.png"];
            //     continue;
            // }
            
            if($row['source'] == 1){
                $resultData[] = ['row_id' => $row['row_id'], 'name' => $row['name'], 'phone' => $row['phone'], 'road' => $row['location_name'], "image" => $row['image_name'], 'district_id' => $row['district_id'], 'upazila_id' => $row['upazila_id'], 'union_id' => $row['union_id'], 'experience' => $row['experience'], 'clicks' => $row['clicks']];
            }else{
                // $data[] = $row;
                
                
                $resultData[] = ['row_id' => $row['row_id'], 'name' => $row['full_name'], 'experience' => $row['experience'], 'road' => $row['village'], 'district_id' => $row['district'], 'upazila_id' => $row['upazila'], 'union_id' => $row['union'], 'phone' => $row['phone'], 'image' => $row['pp_url'], 'clicks' => $row['clicks']];
            }
        }
        
        echo json_encode(['success' => true, 'response' => json_encode($resultData)]);
    }else{
        noDataFound();
    }
}

function getMechanicsForEdit($isNarrow, $user){
    
    $conn = createSqlConnection();
    $conn->set_charset('utf8');
    
    $query = "SELECT * FROM MECHANICS WHERE user = '$user'";
    
    $result = $conn->query($query);
    $dataFound = $result->num_rows > 0;

    if($dataFound){
        $resultData = null;
        $data = null;
        
        $row = $result->fetch_assoc();
        
        if($isNarrow){
            $resultData = ['category' => $row['category'], 
                           'addt_phone' => $row['phone'] ?? '', 
                           'experience' => $row['experience'], 
                           'enabled' => $row['enabled'] == 1,
                           'row_id' => $row['row_id']
                           ];
        }
        
        echo json_encode(['success' => true, 'response' => json_encode($resultData)]);
    }else{
        noDataFound();
    }
}

function getProducts($user, $subCategory){
    
    $conn = createSqlConnection();
    $conn->set_charset('utf8mb4');
    $tableName = "PRODUCTS";
    
    //For public
    $query = "SELECT * FROM $tableName WHERE visibility = 1 AND category = $subCategory";
    
    $result = $conn->query($query);
    $dataFound = $result->num_rows > 0;

    if($dataFound){
        $resultData = null;
        $data = null;
        
        while ($row = $result->fetch_assoc()) {
            $resultData[] = ['row_id' => $row['row_id'], 'title' => $row['title'], 'phone' => $row['phone'], 'district_id' => $row['district_id'], 'upazila_id' => $row['upazila_id'], 'price' => $row['price'], 'images' => $row['images'], 'clicks' => $row['clicks']];
         
        }
    
        
        echo json_encode(['success' => true, 'response' => json_encode($resultData)]);
    }else{
        noDataFound();
    }
}

function getProductDetails($rowId){
    
    $conn = createSqlConnection();
    $conn->set_charset('utf8mb4');
    $tableName = "PRODUCTS";
    
    //For public
    $query = "SELECT $tableName.*, USERS.full_name FROM $tableName JOIN USERS ON $tableName.user = USERS.username WHERE $tableName.row_id = $rowId";
    
    $result = $conn->query($query);
    $dataFound = $result->num_rows > 0;

    if($dataFound){
        $resultData = null;
        $data = null;
        
        $row = $result->fetch_assoc();
        
        $brand = $row['brand'] == null ? "N/A" : $row['brand'];
        
        $resultData = ['desc' => $row['description'], 'condition' => $row['product_condition'], 'phone' => $row['phone'], 'district_id' => $row['district_id'], 'upazila_id' => $row['upazila_id'], 'union_id' => $row['union_id'], 'road' => $row['location_name'], 'price_fixed' => $row['price_fixed'] == 1, 'brand' => $brand, 'seller' => $row['full_name'], 'post_at' => $row['post_time'], 'has_wa' => $row['phone_has_wa'] == 1];
         
        updateViewCount($GLOBALS['SERVICE_TYPE_BUY_SELL'], $rowId, false);
        echo json_encode(['success' => true, 'response' => json_encode($resultData)]);
        
    }else{
        noDataFound();
    }
}


function getEduData($category, $basicOnly, $user){
    
    $conn = createSqlConnection();
    $conn->set_charset('utf8');
    
    $query = "SELECT * FROM EDU_INSTITUTES WHERE category = $category";
    if($basicOnly){
        $query = "SELECT row_id, name, principal_name as principal, 
                 official, email, website, student_total as students, 
                 phone, established_year as year, logo, location_name as road, 
                 district_id, upazila_id, union_id, category
                 FROM EDU_INSTITUTES WHERE user = '$user'";
    }
    
    $result = $conn->query($query);
    $dataFound = $result->num_rows > 0;

    if($dataFound){
        $resultData = null;
        while ($row = $result->fetch_assoc()) {
            
            if($basicOnly){
                $resultData[] = $row;//['row_id' => $row['row_id'], 'name' => $row['name'], 'subtitle' => $row['proprietor'], 'status' => $row['visibility'], 'image' => "https://cdn.minidevbd.com/m/p/icons/ambulance-128.png"];
                continue;
            }
            
            $rowId = $row['row_id'];
            $title = $row['name'];

            $districtId = $row['district_id'];
            $upazilaId = $row['upazila_id'];
            $unionId = $row['union_id'];
            $road = $row['location_name'];
            
            $estYear = $row['established_year'];
            $image_name = $row['logo'] == null ? "" : $row['logo'];
            
            $clicks = $row['clicks'];

            $resultData[] = ['row_id' => $rowId, 'name' => $title, 'loc' => $road, 'district_id' => $districtId, 'upazila_id' => $upazilaId, 'union_id' => $unionId, 'image_name' => $image_name, 'clicks' => $clicks, 'est' => $estYear];
        
        }
        
        echo json_encode(['success' => true, 'response' => json_encode($resultData)]);
    }else{
        noDataFound();
    }
}


function getEduForEdit($type, $rowId){
    
    $conn = createSqlConnection();
    $conn->set_charset('utf8');
    
    $query = "SELECT district_id as district, upazila_id as upazila, 
            union_id `union`, name, principal_name as principal, 
            official, phone, website, email, student_total as students,
            category, established_year as est_year, logo, location_name, 
            eiin FROM EDU_INSTITUTES WHERE row_id = $rowId";
    
    $result = $conn->query($query);
    $dataFound = $result->num_rows > 0;

    if($dataFound){
        $resultData = null;
        $row = $result->fetch_assoc();
        
        echo json_encode(['success' => true, 'response' => json_encode($row)]);
    }else{
        noDataFound();
    }
}

function getHospital($category, $basicOnly, $user){
    
    $conn = createSqlConnection();
    $conn->set_charset('utf8');
    
    $tableName = "HOSPITALS";
    $forAttach = $_GET['for_attach'] ?? '0';
    
    $query = "SELECT * FROM $tableName WHERE visibility = 1 AND category = $category";
    if($basicOnly){
        $query = "SELECT name, row_id, location_name as location, logo, category FROM $tableName WHERE user = '$user'";
    }else if($forAttach == '1'){
        $query = "SELECT * FROM $tableName WHERE visibility = 1 AND category != 4";
    }
    
    $result = $conn->query($query);
    $dataFound = $result->num_rows > 0;

    if($dataFound){
        $resultData = null;
        while ($row = $result->fetch_assoc()) {
            
            if($basicOnly){
                $resultData[] = $row;
                continue;
            }
            
            $rowId = $row['row_id'];
            $title = $row['name'];

            $districtId = $row['district_id'];
            $upazilaId = $row['upazila_id'];
            $unionId = $row['union_id'];
            $road = $row['location_name'];
            $estYear = $row['est_year'];
            $image_name = $row['logo'] == null ? "" : $row['logo'];
            
            $clicks = $row['clicks'];

            $resultData[] = ['row_id' => $rowId, 'name' => $title, 'loc' => $road, 'district_id' => $districtId, 'upazila_id' => $upazilaId, 'union_id' => $unionId, 'logo' => $image_name, 'clicks' => $clicks, 'est' => $estYear, 'category' => $row['category']];
        
        }
        
        echo json_encode(['success' => true, 'response' => json_encode($resultData)]);
    }else{
        noDataFound();
    }
}


function getHealthInstDetails($rowId){
    
    $conn = createSqlConnection();
    $conn->set_charset('utf8mb4');
    $tableName = "HOSPITALS";
    
    //For public
    $query = "SELECT * FROM $tableName WHERE row_id = $rowId";
    
    $result = $conn->query($query);
    $dataFound = $result->num_rows > 0;

    if($dataFound){
        $resultData = null;
        $data = null;
        
        $row = $result->fetch_assoc();
        
        updateViewCount($GLOBALS['SERVICE_TYPE_HOSPITAL'], $rowId, false);
        echo json_encode(['success' => true, 'response' => json_encode($row)]);
        
    }else{
        noDataFound();
    }
}

function getHospitalForEdit($rowId, $user){
    
    $conn = createSqlConnection();
    $conn->set_charset('utf8');
    
    $tableName = "HOSPITALS";
    
    $query = "SELECT name, room_count as rooms, sit_count as sits, est_year, 
                location_name as location, phone, category, district_id as district, 
                upazila_id as upazila, union_id as `union`, official, phone, website, 
                email, timing, about, logo FROM $tableName WHERE row_id = $rowId AND user = '$user'";

    $result = $conn->query($query);
    $dataFound = $result->num_rows > 0;

    if($dataFound){
        $resultData = null;
        $row = $result->fetch_assoc();

        echo json_encode(['success' => true, 'response' => json_encode($row)]);
    }else{
        noDataFound();
    }
}

function getEduDetails($type, $rowId){
    
    $conn = createSqlConnection();
    $conn->set_charset('utf8');
    
    
    $query = "SELECT * FROM EDU_INSTITUTES WHERE row_id = $rowId";
  
    $result = $conn->query($query);
    $dataFound = $result->num_rows > 0;

    if($dataFound){
        $row = $result->fetch_assoc();

        $phone = $row['phone'];
        $official = $row['official'];
        $principal = $row['principal_name'];
        $website = $row['website'];
        $email = $row['email'];
        $studentCount = $row['student_total'];
        
        $resultData = ['phone' => $phone, 'official' => $official, 'principal' => $principal, 'website' => $website, 'email' => $email, 'students' => $studentCount];
        
        echo json_encode(['success' => true, 'response' => json_encode($resultData)]);
        updateViewCount($type, $rowId, false);
        
    }else{
        echo json_encode(['success' => false, 'errcode' => $GLOBALS['ERROR_NO_DATA_FOUND'], 'response' => "No data found in this service"]);
    }
}

function getAmbulanceEditData($user, $rowId){
    
    $conn = createSqlConnection();
    $conn->set_charset('utf8');
    
    $query = "SELECT * FROM AMBULANCE WHERE row_id = $rowId";
    $result = $conn->query($query);
    $dataFound = $result->num_rows > 0;

    if($dataFound){
        $row = $result->fetch_assoc();
        
        echo json_encode(['success' => true, 'response' => json_encode($row)]);
    }else{
        echo json_encode(['success' => false, 'errcode' => $GLOBALS['ERROR_NO_DATA_FOUND'], 'response' => "No data found in this service"]);
    }
}



function getFireData(){
    
    $conn = createSqlConnection();
    $conn->set_charset('utf8');
    
    $query = "SELECT * FROM FIRE_SERVICE WHERE visibility = 1";
    $result = $conn->query($query);
    $dataFound = $result->num_rows > 0;

    if($dataFound){
        $resultData = null;
        while ($row = $result->fetch_assoc()) {
            $resultData[] = $row;
        }
        
        echo json_encode(['success' => true, 'response' => json_encode($resultData)]);
    }else{
        noDataFound();
    }
}

function getPoliceData(){
    $conn = createSqlConnection();
    $conn->set_charset('utf8');
    
    $query = "SELECT * FROM POLICE WHERE visibility = 1";
    $result = $conn->query($query);
    $dataFound = $result->num_rows > 0;

    if($dataFound){
        $resultData = null;
        while ($row = $result->fetch_assoc()) {
            $resultData[] = $row;
        }
        
        echo json_encode(['success' => true, 'response' => json_encode($resultData)]);
    }else{
        noDataFound();
    }
}

function postOrAddService(){
    $conn = createSqlConnection();
    $conn->set_charset('utf8mb4');
    
    $user = $_POST['username'];
    $serviceType = $_POST['service_type'];
    $insertData = null;
    
    if($serviceType == $GLOBALS['SERVICE_TYPE_TUITION']){
        $postData = json_decode($_POST['post_data'], true);
        $eduData = $postData['edu_data'];
        $type = $postData['tuition_type'];
        
        $insertData = $conn->prepare("INSERT INTO TUITION_POSTS (`user`, `type`, education_data, visibility) VALUES (?, ?, ?, 1)");
        $insertData->bind_param("sis", $user, $type, $eduData);
        
    }else if($serviceType == $GLOBALS['SERVICE_TYPE_AMBULANCE']){
        $postData = json_decode($_POST['post_data'], true);

        $insertData = $conn->prepare("INSERT INTO AMBULANCE (`user`, title, proprietor, phone, location_name, service_area, district, upazila, `union`, hospital_id) VALUES (?, ?, ?, ?, ?, ?, ?, ?, ?, ?)");
        $insertData->bind_param("ssssssiiii", $user, $postData['title'], $postData['proprietor'], $postData['phone'], $postData['road'], $postData['service_area'], $postData['district_id'], $postData['upazila_id'], $postData['union_id'], $postData['hospital_id']);
    }else if($serviceType == $GLOBALS['SERVICE_TYPE_EDUCATION']){
        $postData = json_decode($_POST['post_data'], true);

        $category = $postData['category'];
        
        $insertData = $conn->prepare("INSERT INTO EDU_INSTITUTES (`user`, name, principal_name, official, email, website, phone, category, established_year, location_name, district_id, upazila_id, union_id, student_total, eiin, logo) VALUES(?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?)");
        $insertData->bind_param("sssisssiisiiiiis", $user, $postData['name'], $postData['principal'], $postData['official'], $postData['email'], $postData['website'], $postData['phone'], $category, $postData['est_year'], $postData['road'], $postData['district_id'], $postData['upazila_id'], $postData['union_id'], $postData['students'], $postData['eiin'], $postData['logo_name']);
    }else if($serviceType == $GLOBALS['SERVICE_TYPE_MECHANICS']){
        $postData = json_decode($_POST['post_data'], true);

        $source = $postData['source'];
        if($source == 1){//Add for another user
            $insertData = $conn->prepare("INSERT INTO MECHANICS (`user`, name, phone, location_name, district_id, upazila_id, union_id, experience, source, category, image_name) VALUES (?, ?, ?, ?, ?, ?, ?, ?, 1, ?, ?)");
            
            $insertData->bind_param("ssssiiisis", $user, $postData['name'], $postData['phone'], $postData['road'], $postData['district_id'], $postData['upazila_id'], $postData['union_id'], $postData['experience'], $postData['category'], $postData['image_name']);
            
        }else{//Add for self
            $insertData = $conn->prepare("INSERT INTO MECHANICS (`user`, experience, category, phone) VALUES (?, ?, ?, ?)");
            $insertData->bind_param("ssis", $user, $postData['experience'], $postData['category'], $postData['addt_phone']);
        }
    }else if($serviceType == $GLOBALS['SERVICE_TYPE_BUY_SELL']){
        $postData = json_decode($_POST['post_data'], true);
        
        $times = round(microtime(true) * 1000);
        $fixed = $postData['fixed'];
        $insertData = $conn->prepare("INSERT INTO PRODUCTS (`user`, title, phone, phone_has_wa, brand, product_condition, description, price, price_fixed, images, location_name, district_id, upazila_id, union_id, category, post_time, visibility) VALUES (?, ?, ?, ?, ?, ?, ?, ?, $fixed, ?, ?, ?, ?, ?, ?, ?, 1)");
        $insertData->bind_param("sssisisissiiiii", $user, $postData['title'], $postData['phone'], $postData['has_whatsapp'], $postData['brand'], $postData['condition'], $postData['desc'], $postData['price'], $postData['images'], $postData['road'], $postData['district_id'], $postData['upazila_id'], $postData['union_id'], $postData['category'], $times);
        
    }else if($serviceType == $GLOBALS['SERVICE_TYPE_BLOOD_DONOR']){
        $postData = json_decode($_POST['post_data'], true);
        
        $insertData = $conn->prepare("INSERT INTO BLOOD_DONORS (`user`, last_donate, visibility) VALUES(?, ?, 1)");
        $insertData->bind_param("si", $user, $postData['last_donate']);
    }else if($serviceType == $GLOBALS['SERVICE_TYPE_HOSPITAL']){
        
        $postData = json_decode($_POST['post_data'], true);
        $logoName = $postData['logo_name'] ?? "";
        
        $insertData = $conn->prepare("INSERT INTO HOSPITALS (`user`, name, phone, email, website, 
                                        est_year, official, timing, sit_count, room_count, logo, 
                                        district_id, upazila_id, union_id, location_name, category, about,
                                        visibility) VALUES(?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, 1)");
                                        
        $insertData->bind_param("sssssiisiisiiisis", $user, $postData['name'], $postData['phone'],
                                $postData['email'], $postData['website'], $postData['est_year'], 
                                $postData['official'], $postData['timing'], $postData['sits'],
                                $postData['rooms'], $logoName, $postData['district'],
                                $postData['upazila'], $postData['union'], $postData['road'], 
                                $postData['category'], $postData['about']);
    }
    
    $result = $insertData->execute();

    if($result && $conn->affected_rows > 0){
        echo json_encode(['success' => true, 'response' => "Data added successfully", 'added_id' => $conn->insert_id]);
        //Echo success
    }else{
        echo json_encode(['success' => false, 'errcode' => $GLOBALS['ERROR_TYPE_DATA_ADD'], 'response'=> "Failed to add data."]);
        //Echo failed
    }
}


function updateService(){
    $rowId = $_POST['row_id'];
    
    if($rowId == -1){
        postOrAddService();
        return;
    }
    
    $conn = createSqlConnection();
    $conn->set_charset('utf8mb4');
    
    $user = $_POST['username'];
    $serviceType = $_POST['service_type'];
    $updateData = null;
    
    if($serviceType == $GLOBALS['SERVICE_TYPE_TUITION']){
        $postData = json_decode($_POST['post_data'], true);
        $eduData = $postData['edu_data'];
        $type = $postData['tuition_type'];
        
        $updateData = $conn->prepare("UPDATE TUITION_POSTS SET `type` = ?, education_data = ? WHERE row_id = $rowId AND user = '$user'");
        $updateData->bind_param("is", $type, $eduData);
        
    }else if($serviceType == $GLOBALS['SERVICE_TYPE_AMBULANCE']){
        $postData = json_decode($_POST['post_data'], true);

        $updateData = $conn->prepare("UPDATE AMBULANCE SET title = ?, proprietor = ?, phone = ?, location_name = ?, service_area = ?, district = ?, upazila = ?, `union` = ?, hospital_id = ? WHERE row_id = $rowId AND user = '$user'");
        $updateData->bind_param("sssssiiii", $postData['title'], $postData['proprietor'], $postData['phone'], $postData['road'], $postData['service_area'], $postData['district_id'], $postData['upazila_id'], $postData['union_id'], $postData['hospital_id']);
        
    }else if($serviceType == $GLOBALS['SERVICE_TYPE_EDUCATION']){
        $postData = json_decode($_POST['post_data'], true);

        $category = $postData['category'];
        
        $logoName = $postData['logo_name'] ?? "";
        $unionId = 0;
        
        $tableName = "EDU_INSTITUTES";
        
        $updateData = $conn->prepare("UPDATE $tableName SET name = ?, principal_name = ?, official = ?, email = ?, website = ?, phone = ?, category = ?, established_year = ?, location_name = ?, district_id = ?, upazila_id = ?, union_id = ?, student_total = ?, eiin = ?, logo = ? WHERE row_id = $rowId AND user = '$user'");
        $updateData->bind_param("ssisssiisiiiiis", $postData['name'], $postData['principal'], 
                                $postData['official'], $postData['email'], $postData['website'], 
                                $postData['phone'], $category, $postData['est_year'], $postData['road'], 
                                $postData['district_id'], $postData['upazila_id'], $unionId, 
                                $postData['students'], $postData['eiin'], $logoName);
        
    }else if($serviceType == $GLOBALS['SERVICE_TYPE_MECHANICS']){
        $postData = json_decode($_POST['post_data'], true);

        $source = $postData['source'];
        if($source == 1){//Update for other users
            $updateData = $conn->prepare("UPDATE MECHANICS SET name = ?, phone = ?, location_name = ?, district_id = ?, upazila_id = ?, union_id = ?, experience = ?, source = 1, category = ? WHERE row_id = $rowId AND user = '$user'");
            
            $updateData->bind_param("sssiiisi", $postData['name'], $postData['addt_phone'], $postData['road'], $postData['district_id'], $postData['upazila_id'], $postData['union_id'], $postData['experience'], $postData['category']);
        }else{//Update for self
            $updateData = $conn->prepare("UPDATE MECHANICS SET experience = ?, phone = ?, category = ? WHERE row_id = ? AND user = '$user'");
            $updateData->bind_param("ssii", $postData['experience'], $postData['addt_phone'], $postData['category'], $rowId);
        }
    }else if($serviceType == $GLOBALS['SERVICE_TYPE_BLOOD_DONOR']){
        $postData = json_decode($_POST['post_data'], true);
        
        $updateData = $conn->prepare("UPDATE BLOOD_DONORS SET last_donate = ? WHERE row_id = $rowId AND user = '$user'");
        $updateData->bind_param("i", $postData['last_donate']);
    }else if($serviceType == $GLOBALS['SERVICE_TYPE_HOSPITAL']){
        
        $postData = json_decode($_POST['post_data'], true);
        $logoName = $postData['logo_name'] ?? "";
        
        $updateData = $conn->prepare("UPDATE HOSPITALS SET name = ?, phone = ?, email = ?, website = ?, 
                                        est_year = ?, official = ?, timing = ?, sit_count = ?, room_count = ?, 
                                        logo = ?, district_id = ?, upazila_id = ?, union_id = ?, location_name = ?,
                                        category = ?, about = ? WHERE row_id = $rowId AND user = '$user'");
                                        
        $updateData->bind_param("ssssiisiisiiisis", $postData['name'], $postData['phone'],
                                $postData['email'], $postData['website'], $postData['est_year'], 
                                $postData['official'], $postData['timing'], $postData['sits'],
                                $postData['rooms'], $logoName, $postData['district'],
                                $postData['upazila'], $postData['union'], $postData['road'],
                                $postData['category'], $postData['about']);
    }
    
    $result = $updateData->execute();

    if($result && $conn->affected_rows > 0){
        echo json_encode(['success' => true, 'response' => "Data updated successfully"]);
        //Echo success
    }else{
        echo json_encode(['success' => false, 'errcode' => $GLOBALS['ERROR_TYPE_DATA_ADD'], 'response'=> "Failed to update data."]);
        //Echo failed
    }
}

function updateViewCount($service, $rowId, $getResponse = true){
    $conn = createSqlConnection();
    
    $query = "SELECT * FROM SERVICES WHERE service = $service";
    $result = $conn->query($query);
    $dataFound = $result->num_rows > 0;

    if($dataFound){
        $row = $result->fetch_assoc();
        $tableName = $row['table_name'];
        
        $stmt = $conn->prepare("UPDATE $tableName SET clicks = clicks + 1 WHERE row_id = ?");
        $stmt->bind_param('i', $rowId);
        $stmt->execute();

        if($getResponse){
            if($conn->affected_rows > 0){
                echo json_encode(['success' => true, 'response' => "Updated 1 view or click"]);
            }else {
                echo json_encode(['success' => false, 'errcode' => 343, 'response' => "No row found with id '$rowId' on table '$tableName'"]);
            }
        }
    }
}










?>